global wallworm_mapsize = [-16384,16384]
global wallworm_brush_entity_list = #("worldspawn","func_lod","func_areaportalwindow","func_wall","func_clip_vphysics","func_brush","env_embers","env_bubbles","game_zone_player","color_correction_volume","func_movelinear","func_water_analog","func_rotating","func_platrot","func_button","func_rot_button","momentary_rot_button","func_door","func_door_rotating","func_dustmotes","func_smokevolume","func_dustcloud","func_physbox","func_areaportal","func_occluder","func_breakable","func_breakable_surf","func_conveyor","func_detail","func_viscluster","func_illusionary","func_precipitation","func_wall_toggle","func_guntarget","func_trackautochange","func_trackchange","func_tracktrain","func_tanktrain","func_traincontrols","trigger_autosave","trigger_changelevel","trigger_gravity","trigger_playermovement","trigger_soundscape","trigger_hurt","trigger_remove","trigger_multiple","trigger_once","trigger_look","trigger_push","trigger_wind","trigger_impact","trigger_proximity","trigger_teleport","trigger_transition","trigger_serverragdoll","func_reflective_glass")

global wallworm_worldspawn_CA = attributes "WW Entity worldspawn" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="worldspawn"
local hasOutputs = false
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddContext","AddOutput","ClearContext","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","RemoveContext")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdark="0"
local propMapstartdark=#("0","1")
local propValgametitle="0"
local propMapgametitle=#("0","1")
local propValnewunit="0"
local propMapnewunit=#("0","1")
local propValcoldworld="0"
local propMapcoldworld=#("0","1")
local exportProps=#("targetname","message","skyname","chaptertitle","startdark","gametitle","newunit","maxoccludeearea","minoccluderarea","maxoccludeearea_x360","minoccluderarea_x360","maxpropscreenwidth","minpropscreenwidth","detailvbsp","detailmaterial","coldworld","responsecontext")

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
message type:#string ui:wwmt_message_ui default:""
skyname type:#string ui:wwmt_skyname_ui default:"sky_day01_01"
chaptertitle type:#string ui:wwmt_chaptertitle_ui default:""
startdark type:#string ui:wwmt_startdark_ui default:"0"
gametitle type:#string ui:wwmt_gametitle_ui default:"0"
newunit type:#string ui:wwmt_newunit_ui default:"0"
maxoccludeearea type:#float ui:wwmt_maxoccludeearea_ui default:0
minoccluderarea type:#float ui:wwmt_minoccluderarea_ui default:0
maxoccludeearea_x360 type:#float ui:wwmt_maxoccludeearea_x360_ui default:0
minoccluderarea_x360 type:#float ui:wwmt_minoccluderarea_x360_ui default:0
maxpropscreenwidth type:#float ui:wwmt_maxpropscreenwidth_ui default:-1
minpropscreenwidth type:#float ui:wwmt_minpropscreenwidth_ui default:0
detailvbsp type:#string ui:wwmt_detailvbsp_ui default:"detail.vbsp"
detailmaterial type:#string ui:wwmt_detailmaterial_ui default:"detail/detailsprites"
coldworld type:#string ui:wwmt_coldworld_ui default:"0"
responsecontext type:#string ui:wwmt_responsecontext_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "worldspawn"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_message_ui_label "Map Description / Title" 
editText wwmt_message_ui "" type:#string
label wwmt_skyname_ui_label "SkyBox Texture Name" 
editText wwmt_skyname_ui "" type:#string
label wwmt_chaptertitle_ui_label "Chapter Title Message"  toolTip:"Chapter Title Message: Chapter Title that appears onscreen when this level starts."
editText wwmt_chaptertitle_ui "" type:#string toolTip:"Chapter Title Message: Chapter Title that appears onscreen when this level starts."
dropdownlist wwmt_startdark_ui "Level Fade In" type:#string items:#("No","Yes")
on wwmt_startdark_ui selected i do startdark = propMapstartdark[i] 
dropdownlist wwmt_gametitle_ui "Display Game Title" type:#string items:#("No","Yes") toolTip:"Display Game Title: Game Title that appears onscreen when this level starts. ="
on wwmt_gametitle_ui selected i do gametitle = propMapgametitle[i] 
dropdownlist wwmt_newunit_ui "New Level Unit" type:#string items:#("No, keep current","Yes, clear previous levels") toolTip:"New Level Unit: Used to clear out savegame data of previous levels to keep the savegame size as small as possible. Only set it to Yes if the player cannot return to any previous levels. ="
on wwmt_newunit_ui selected i do newunit = propMapnewunit[i] 
spinner wwmt_maxoccludeearea_ui "Max occludee " type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Max occludee area: [Used on PC] Prevents occlusion testing for entities that take up more than X percent of the screen."
spinner wwmt_minoccluderarea_ui "Min occluder " type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Min occluder area: [Used on PC] Prevents occluders from being used if they take up less than X percent of the screen."
spinner wwmt_maxoccludeearea_x360_ui "Max occludee " type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Max occludee area (Xbox): [Used on 360] Prevents occlusion testing for entities that take up more than X percent of the screen."
spinner wwmt_minoccluderarea_x360_ui "Min occluder " type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Min occluder area (Xbox): [Used on 360] Prevents occluders from being used if they take up less than X percent of the screen."
spinner wwmt_maxpropscreenwidth_ui "Start Fade Pi" type:#float scale:0.001 range:[-10000.000,10000.000,-1] toolTip:"Start Fade Pixels: Number of pixels wide at which all props in the level start to fade (<0 = use fademaxdist). This number is ignored if the prop has a specific fade distance specified."
spinner wwmt_minpropscreenwidth_ui "End Fade Pixe" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"End Fade Pixels: Minimum number of pixels wide at which the prop is visible (0 = don't fade out). This number is ignored if the prop has a specific fade distance specified."
label wwmt_detailvbsp_ui_label "Detail.vbsp file"  toolTip:"Detail.vbsp file: Detail.vbsp file to use for emitting detail props (found in directory <root>/modname)"
editText wwmt_detailvbsp_ui "" type:#string toolTip:"Detail.vbsp file: Detail.vbsp file to use for emitting detail props (found in directory <root>/modname)"
label wwmt_detailmaterial_ui_label "Detail material file"  toolTip:"Detail material file: Material for detail sprites to use for drawing detail props"
editText wwmt_detailmaterial_ui "" type:#string toolTip:"Detail material file: Material for detail sprites to use for drawing detail props"
dropdownlist wwmt_coldworld_ui "World is cold" type:#string items:#("No","Yes")
on wwmt_coldworld_ui selected i do coldworld = propMapcoldworld[i] 
label wwmt_responsecontext_ui_label "Response Contexts"  toolTip:"Response Contexts: value2,etc'. When this entity speaks, the list of keys & values will be passed to the response rules system."
editText wwmt_responsecontext_ui "" type:#string toolTip:"Response Contexts: value2,etc'. When this entity speaks, the list of keys & values will be passed to the response rules system."

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=worldspawn&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: worldspawn" address:"https://developer.valvesoftware.com/wiki/worldspawn?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdark != undefined AND findItem propMapstartdark startdark == 0 then (
 append propMapstartdark startdark
tmp = wwmt_startdark_ui.items
 append tmp startdark
wwmt_startdark_ui.items = tmp
wwmt_startdark_ui.selection = propMapstartdark.count
) else ( 
 if startdark != undefined then (
wwmt_startdark_ui.selection = (findItem propMapstartdark startdark)
)
)
 if gametitle != undefined AND findItem propMapgametitle gametitle == 0 then (
 append propMapgametitle gametitle
tmp = wwmt_gametitle_ui.items
 append tmp gametitle
wwmt_gametitle_ui.items = tmp
wwmt_gametitle_ui.selection = propMapgametitle.count
) else ( 
 if gametitle != undefined then (
wwmt_gametitle_ui.selection = (findItem propMapgametitle gametitle)
)
)
 if newunit != undefined AND findItem propMapnewunit newunit == 0 then (
 append propMapnewunit newunit
tmp = wwmt_newunit_ui.items
 append tmp newunit
wwmt_newunit_ui.items = tmp
wwmt_newunit_ui.selection = propMapnewunit.count
) else ( 
 if newunit != undefined then (
wwmt_newunit_ui.selection = (findItem propMapnewunit newunit)
)
)
 if coldworld != undefined AND findItem propMapcoldworld coldworld == 0 then (
 append propMapcoldworld coldworld
tmp = wwmt_coldworld_ui.items
 append tmp coldworld
wwmt_coldworld_ui.items = tmp
wwmt_coldworld_ui.selection = propMapcoldworld.count
) else ( 
 if coldworld != undefined then (
wwmt_coldworld_ui.selection = (findItem propMapcoldworld coldworld)
)
)

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_lod_CA = attributes "WW Entity func_lod" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_lod"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsolid="0"
local propMapsolid=#("0","1")
local exportProps=#("disappeardist","solid","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
disappeardist type:#integer ui:wwmt_disappeardist_ui default:2000
solid type:#string ui:wwmt_solid_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_lod"
spinner wwmt_disappeardist_ui "Disappear Dis" type:#integer range:[-10000,10000,2000] toolTip:"Disappear Distance: Distance at which these brushes should fade out."
dropdownlist wwmt_solid_ui "Solid" type:#string items:#("Solid","Nonsolid") toolTip:"Solid: Set whether or not these brushes should collide with other entities. ="
on wwmt_solid_ui selected i do solid = propMapsolid[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_lod" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_lod_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_lod&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_lod" address:"https://developer.valvesoftware.com/wiki/func_lod?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if solid != undefined AND findItem propMapsolid solid == 0 then (
 append propMapsolid solid
tmp = wwmt_solid_ui.items
 append tmp solid
wwmt_solid_ui.items = tmp
wwmt_solid_ui.selection = propMapsolid.count
) else ( 
 if solid != undefined then (
wwmt_solid_ui.selection = (findItem propMapsolid solid)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_areaportalwindow_CA = attributes "WW Entity func_areaportalwindow" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_areaportalwindow"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetFadeEndDistance","SetFadeStartDistance")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 128.0 255.0)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("wwmt_target","fadestartdist","fadedist","translucencylimit","backgroundbmodel","portalversion","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
fadestartdist type:#integer ui:wwmt_fadestartdist_ui default:128
fadedist type:#integer ui:wwmt_fadedist_ui default:512
translucencylimit type:#string ui:wwmt_translucencylimit_ui default:"0.2"
backgroundbmodel type:#string ui:wwmt_backgroundbmodel_ui default:""
portalversion type:#string ui:wwmt_portalversion_ui default:"1"
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_areaportalwindow"
label wwmt_target_ui_label "Rendered Window"  toolTip:"Rendered Window: The name of a brush model to render as the window."
editText wwmt_target_ui "" type:#string toolTip:"Rendered Window: The name of a brush model to render as the window."
pickbutton wwmt_target_pickme_ui "Pick Rendered Window" message:"Pick Target Entity for Rendered Window" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_fadestartdist_ui "Fade Start Di" type:#integer range:[-10000,10000,128] toolTip:"Fade Start Distance: When the viewer is closer than this distance, the alpha is set to 'TranslucencyLimit'."
spinner wwmt_fadedist_ui "Fade End Dist" type:#integer range:[-10000,10000,512] toolTip:"Fade End Distance: When the viewer is at this distance, the portal becomes solid and closes off."
label wwmt_translucencylimit_ui_label "Translucency limit"  toolTip:"Translucency limit: This value limits the translucency of the bmodel and prevents it from becoming invisible when the viewer is right on top of it."
editText wwmt_translucencylimit_ui "" type:#string toolTip:"Translucency limit: This value limits the translucency of the bmodel and prevents it from becoming invisible when the viewer is right on top of it."
label wwmt_backgroundbmodel_ui_label "Foreground bmodel"  toolTip:"Foreground bmodel: (Optional) brush model that is drawn after the fading brush model. This model should have alpha in its textures so you can see through it."
editText wwmt_backgroundbmodel_ui "" type:#string toolTip:"Foreground bmodel: (Optional) brush model that is drawn after the fading brush model. This model should have alpha in its textures so you can see through it."
label wwmt_portalversion_ui_label "Portal Version"  toolTip:"Portal Version: (Don't change). Differentiates between shipping HL2 maps and maps using new engine features."
editText wwmt_portalversion_ui "" type:#string toolTip:"Portal Version: (Don't change). Differentiates between shipping HL2 maps and maps using new engine features."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_areaportalwindow" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_areaportalwindow_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_areaportalwindow&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_areaportalwindow" address:"https://developer.valvesoftware.com/wiki/func_areaportalwindow?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_wall_CA = attributes "WW Entity func_wall" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_wall"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("_minlight","targetname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_wall"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_wall" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_wall_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_wall" address:"https://developer.valvesoftware.com/wiki/func_wall?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_clip_vphysics_CA = attributes "WW Entity func_clip_vphysics" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_clip_vphysics"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("filtername","targetname","startdisabled")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
filtername type:#string ui:wwmt_filtername_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_clip_vphysics"
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator collides with me. See filter_activator_name for more explanation. Allow means 'Allow to Block' for this entity."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator collides with me. See filter_activator_name for more explanation. Allow means 'Allow to Block' for this entity."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_clip_vphysics" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_clip_vphysics_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_clip_vphysics&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_clip_vphysics" address:"https://developer.valvesoftware.com/wiki/func_clip_vphysics?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_brush_CA = attributes "WW Entity func_brush" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_brush"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","Disable","DisableShadow","Enable","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetExcluded","SetInvert","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsolidity="0"
local propMapsolidity=#("0","1","2")
local propValinvert_exclusion="0"
local propMapinvert_exclusion=#("0","1")
local propValsolidbsp="0"
local propMapsolidbsp=#("0","1")
local propValvrad_brush_cast_shadows="0"
local propMapvrad_brush_cast_shadows=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValinputfilter="0"
local propMapinputfilter=#("0","8","16","32")
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("_minlight","solidity","excludednpc","invert_exclusion","solidbsp","vrad_brush_cast_shadows","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","inputfilter","startdisabled","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
solidity type:#string ui:wwmt_solidity_ui default:"0"
excludednpc type:#string ui:wwmt_excludednpc_ui default:""
invert_exclusion type:#string ui:wwmt_invert_exclusion_ui default:"0"
solidbsp type:#string ui:wwmt_solidbsp_ui default:"0"
vrad_brush_cast_shadows type:#string ui:wwmt_vrad_brush_cast_shadows_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
inputfilter type:#string ui:wwmt_inputfilter_ui default:"0"
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_brush"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
dropdownlist wwmt_solidity_ui "Solidity" type:#string items:#("Toggle","Never Solid","Always Solid") toolTip:"Solidity: Used to control the solidity/collision of these brushes. ="
on wwmt_solidity_ui selected i do solidity = propMapsolidity[i] 
label wwmt_excludednpc_ui_label "NPC class excluded from collisions"  toolTip:"NPC class excluded from collisions: If an NPC classname is specified here, NPCs of that type won't collide with these brushes. In Episodic, you may also specify an individual entity's name."
editText wwmt_excludednpc_ui "" type:#string toolTip:"NPC class excluded from collisions: If an NPC classname is specified here, NPCs of that type won't collide with these brushes. In Episodic, you may also specify an individual entity's name."
dropdownlist wwmt_invert_exclusion_ui "Invert NPC class exclusion" type:#string items:#("No","Yes") toolTip:"Invert NPC class exclusion: If set, then the excluded NPC class will consider this brush solid, and all other NPC classes will consider it non-solid. ="
on wwmt_invert_exclusion_ui selected i do invert_exclusion = propMapinvert_exclusion[i] 
dropdownlist wwmt_solidbsp_ui "Solid BSP" type:#string items:#("No","Yes") toolTip:"Solid BSP: Set this if this brush is in heirarchy with a moving object of some kind, and the player can stand on this brush. ="
on wwmt_solidbsp_ui selected i do solidbsp = propMapsolidbsp[i] 
dropdownlist wwmt_vrad_brush_cast_shadows_ui "Shadows" type:#string items:#("No","Yes") toolTip:"Shadows: Set this if this brush casts lightmap shadows. ="
on wwmt_vrad_brush_cast_shadows_ui selected i do vrad_brush_cast_shadows = propMapvrad_brush_cast_shadows[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_inputfilter_ui "Input Filter" type:#string items:#("Allow all inputs","Ignore Touch/Untouch","Ignore Use","Ignore All") toolTip:"Input Filter: Used to specify which inputs this entity will accept. ="
on wwmt_inputfilter_ui selected i do inputfilter = propMapinputfilter[i] 
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "Ignore player +USE" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_brush" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_brush_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_brush&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_brush" address:"https://developer.valvesoftware.com/wiki/func_brush?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if solidity != undefined AND findItem propMapsolidity solidity == 0 then (
 append propMapsolidity solidity
tmp = wwmt_solidity_ui.items
 append tmp solidity
wwmt_solidity_ui.items = tmp
wwmt_solidity_ui.selection = propMapsolidity.count
) else ( 
 if solidity != undefined then (
wwmt_solidity_ui.selection = (findItem propMapsolidity solidity)
)
)
 if invert_exclusion != undefined AND findItem propMapinvert_exclusion invert_exclusion == 0 then (
 append propMapinvert_exclusion invert_exclusion
tmp = wwmt_invert_exclusion_ui.items
 append tmp invert_exclusion
wwmt_invert_exclusion_ui.items = tmp
wwmt_invert_exclusion_ui.selection = propMapinvert_exclusion.count
) else ( 
 if invert_exclusion != undefined then (
wwmt_invert_exclusion_ui.selection = (findItem propMapinvert_exclusion invert_exclusion)
)
)
 if solidbsp != undefined AND findItem propMapsolidbsp solidbsp == 0 then (
 append propMapsolidbsp solidbsp
tmp = wwmt_solidbsp_ui.items
 append tmp solidbsp
wwmt_solidbsp_ui.items = tmp
wwmt_solidbsp_ui.selection = propMapsolidbsp.count
) else ( 
 if solidbsp != undefined then (
wwmt_solidbsp_ui.selection = (findItem propMapsolidbsp solidbsp)
)
)
 if vrad_brush_cast_shadows != undefined AND findItem propMapvrad_brush_cast_shadows vrad_brush_cast_shadows == 0 then (
 append propMapvrad_brush_cast_shadows vrad_brush_cast_shadows
tmp = wwmt_vrad_brush_cast_shadows_ui.items
 append tmp vrad_brush_cast_shadows
wwmt_vrad_brush_cast_shadows_ui.items = tmp
wwmt_vrad_brush_cast_shadows_ui.selection = propMapvrad_brush_cast_shadows.count
) else ( 
 if vrad_brush_cast_shadows != undefined then (
wwmt_vrad_brush_cast_shadows_ui.selection = (findItem propMapvrad_brush_cast_shadows vrad_brush_cast_shadows)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if inputfilter != undefined AND findItem propMapinputfilter inputfilter == 0 then (
 append propMapinputfilter inputfilter
tmp = wwmt_inputfilter_ui.items
 append tmp inputfilter
wwmt_inputfilter_ui.items = tmp
wwmt_inputfilter_ui.selection = propMapinputfilter.count
) else ( 
 if inputfilter != undefined then (
wwmt_inputfilter_ui.selection = (findItem propMapinputfilter inputfilter)
)
)
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_env_embers_CA = attributes "WW Entity env_embers" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_embers"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValparticletype="0"
local propMapparticletype=#("0","1","2")
local exportProps=#("particletype","density","lifetime","speed","rendercolor","targetname","parentname","angles")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
particletype type:#string ui:wwmt_particletype_ui default:"0"
density type:#integer ui:wwmt_density_ui default:50
lifetime type:#integer ui:wwmt_lifetime_ui default:4
speed type:#integer ui:wwmt_speed_ui default:32
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "env_embers"
dropdownlist wwmt_particletype_ui "Ember type" type:#string items:#("Normal","Smooth Fade","Pulled")
on wwmt_particletype_ui selected i do particletype = propMapparticletype[i] 
spinner wwmt_density_ui "Density (part" type:#integer range:[-10000,10000,50]
spinner wwmt_lifetime_ui "Particle Life" type:#integer range:[-10000,10000,4]
spinner wwmt_speed_ui "Particle Spee" type:#integer range:[-10000,10000,32]
colorPicker wwmt_rendercolor_ui "Ember Color (R G B)" color:( color 255 255 255 )
spinner wwmt_rendercolor_inensity_ui "Ember Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Ember Color (R G B)"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start On" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Toggle" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with env_embers" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"env_embers_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_embers&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_embers" address:"https://developer.valvesoftware.com/wiki/env_embers?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if particletype != undefined AND findItem propMapparticletype particletype == 0 then (
 append propMapparticletype particletype
tmp = wwmt_particletype_ui.items
 append tmp particletype
wwmt_particletype_ui.items = tmp
wwmt_particletype_ui.selection = propMapparticletype.count
) else ( 
 if particletype != undefined then (
wwmt_particletype_ui.selection = (findItem propMapparticletype particletype)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_env_bubbles_CA = attributes "WW Entity env_bubbles" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="env_bubbles"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("Activate","AddOutput","ClearParent","Deactivate","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetCurrent","SetDensity","SetFrequency","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("density","frequency","current","targetname","parentname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
density type:#integer ui:wwmt_density_ui default:2
frequency type:#integer ui:wwmt_frequency_ui default:2
current type:#integer ui:wwmt_current_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "env_bubbles"
spinner wwmt_density_ui "Bubble densit" type:#integer range:[-10000,10000,2]
spinner wwmt_frequency_ui "Bubble freque" type:#integer range:[-10000,10000,2]
spinner wwmt_current_ui "Speed of Curr" type:#integer range:[-10000,10000,0] toolTip:"Speed of Current: The speed of the water current in the volume, used to move the bubbles."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start Off" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with env_bubbles" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"env_bubbles_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=env_bubbles&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: env_bubbles" address:"https://developer.valvesoftware.com/wiki/env_bubbles?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_game_zone_player_CA = attributes "WW Entity game_zone_player" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="game_zone_player"
local hasOutputs = true
local availableOutputs=#("OnPlayerInZone","OnPlayerOutZone","OnUser1","OnUser2","OnUser3","OnUser4","PlayersInCount","PlayersOutCount")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","CountPlayersInZone","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("targetname","parentname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "game_zone_player"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with game_zone_player" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"game_zone_player_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=game_zone_player&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: game_zone_player" address:"https://developer.valvesoftware.com/wiki/game_zone_player?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_color_correction_volume_CA = attributes "WW Entity color_correction_volume" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="color_correction_volume"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("fadeduration","maxweight","filename","targetname","startdisabled")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
fadeduration type:#float ui:wwmt_fadeduration_ui default:10.0
maxweight type:#float ui:wwmt_maxweight_ui default:1.0
filename type:#string ui:wwmt_filename_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "color_correction_volume"
spinner wwmt_fadeduration_ui "Lookup Fade D" type:#float scale:0.001 range:[-10000.000,10000.000,10] toolTip:"Lookup Fade Duration: This is the duration for the lookup to fade in/out on extry/exit"
spinner wwmt_maxweight_ui "Maximum Weigh" type:#float scale:0.001 range:[-10000.000,10000.000,1] toolTip:"Maximum Weight: This is the maximum weight for this lookup"
label wwmt_filename_ui_label "Lookup Table Filename"  toolTip:"Lookup Table Filename: This is the lookup table filename"
editText wwmt_filename_ui "" type:#string toolTip:"Lookup Table Filename: This is the lookup table filename"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with color_correction_volume" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"color_correction_volume_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=color_correction_volume&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: color_correction_volume" address:"https://developer.valvesoftware.com/wiki/color_correction_volume?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_movelinear_CA = attributes "WW Entity func_movelinear" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_movelinear"
local hasOutputs = true
local availableOutputs=#("OnFullyClosed","OnFullyOpen","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Close","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Open","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetPosition","SetSpeed")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("movedir","startposition","speed","movedistance","blockdamage","startsound","stopsound","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
movedir type:#string ui:wwmt_movedir_ui default:"0 0 0"
startposition type:#float ui:wwmt_startposition_ui default:0
speed type:#integer ui:wwmt_speed_ui default:100
movedistance type:#float ui:wwmt_movedistance_ui default:100
blockdamage type:#float ui:wwmt_blockdamage_ui default:0
startsound type:#string ui:wwmt_startsound_ui default:""
stopsound type:#string ui:wwmt_stopsound_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_movelinear"
label wwmt_movedir_ui_label "Move Direction (Pitch Yaw Roll)"  toolTip:"Move Direction (Pitch Yaw Roll): The direction the brushes will move, when told to."
editText wwmt_movedir_ui "" type:#string toolTip:"Move Direction (Pitch Yaw Roll): The direction the brushes will move, when told to."
spinner wwmt_startposition_ui "Start Positio" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Start Position: Position of brush when spawned. The range is a value between 0.0 and 1.0, where 0 is the starting position and 1 is the starting position + (move direction * move distance)."
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100] toolTip:"Speed: The speed that the brush moves, in inches per second."
spinner wwmt_movedistance_ui "Move Distance" type:#float scale:0.001 range:[-10000.000,10000.000,100] toolTip:"Move Distance: The distance from the starting point that the brush should move, in inches."
spinner wwmt_blockdamage_ui "Block Damage" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Block Damage: The amount of damage to do to any entity that blocks the brushes, per frame."
label wwmt_startsound_ui_label "Sound played when the brush starts moving." 
editText wwmt_startsound_ui "" type:#string
label wwmt_stopsound_ui_label "Sound played when the brush stops moving." 
editText wwmt_stopsound_ui "" type:#string
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_8_ui.checked == true then (
sfs+=8
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_8_ui "Not Solid" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_movelinear" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_movelinear_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_movelinear&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_movelinear" address:"https://developer.valvesoftware.com/wiki/func_movelinear?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_water_analog_CA = attributes "WW Entity func_water_analog" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_water_analog"
local hasOutputs = true
local availableOutputs=#("OnFullyClosed","OnFullyOpen","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Close","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Open","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetPosition")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("movedir","startposition","speed","movedistance","startsound","stopsound","waveheight","targetname","parentname","origin")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
movedir type:#string ui:wwmt_movedir_ui default:"0 0 0"
startposition type:#float ui:wwmt_startposition_ui default:0
speed type:#integer ui:wwmt_speed_ui default:100
movedistance type:#float ui:wwmt_movedistance_ui default:100
startsound type:#string ui:wwmt_startsound_ui default:""
stopsound type:#string ui:wwmt_stopsound_ui default:""
waveheight type:#string ui:wwmt_waveheight_ui default:"3.0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_water_analog"
label wwmt_movedir_ui_label "Move Direction (Pitch Yaw Roll)"  toolTip:"Move Direction (Pitch Yaw Roll): The direction the water will move, when told to 'Open'."
editText wwmt_movedir_ui "" type:#string toolTip:"Move Direction (Pitch Yaw Roll): The direction the water will move, when told to 'Open'."
spinner wwmt_startposition_ui "Start Positio" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Start Position: Position of the water brush when spawned. The range is a value between 0.0 and 1.0, where 0 is the starting position and 1 is the starting position + (move direction * move distance)."
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100] toolTip:"Speed: The speed that the water brush moves, in inches per second."
spinner wwmt_movedistance_ui "Move Distance" type:#float scale:0.001 range:[-10000.000,10000.000,100] toolTip:"Move Distance: The distance from the starting point that the water brush should move, in inches."
label wwmt_startsound_ui_label "Sound played when the water brush starts moving." 
editText wwmt_startsound_ui "" type:#string
label wwmt_stopsound_ui_label "Sound played when the water brush stops moving." 
editText wwmt_stopsound_ui "" type:#string
label wwmt_waveheight_ui_label "Wave Height" 
editText wwmt_waveheight_ui "" type:#string
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_water_analog" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_water_analog_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_water_analog&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_water_analog" address:"https://developer.valvesoftware.com/wiki/func_water_analog?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_rotating_CA = attributes "WW Entity func_rotating" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_rotating"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Reverse","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","Start","StartBackward","StartForward","Stop","StopAtStartPos","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsolidbsp="0"
local propMapsolidbsp=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("maxspeed","fanfriction","message","volume","_minlight","dmg","solidbsp","targetname","parentname","origin","angles","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
maxspeed type:#integer ui:wwmt_maxspeed_ui default:100
fanfriction type:#integer ui:wwmt_fanfriction_ui default:20
message type:#string ui:wwmt_message_ui default:""
volume type:#integer ui:wwmt_volume_ui default:10
_minlight type:#string ui:wwmt__minlight_ui default:""
dmg type:#integer ui:wwmt_dmg_ui default:0
solidbsp type:#string ui:wwmt_solidbsp_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_rotating"
spinner wwmt_maxspeed_ui "Max Rotation " type:#integer range:[-10000,10000,100] toolTip:"Max Rotation Speed: The maximum rotation speed of the brushes, in degrees per second."
spinner wwmt_fanfriction_ui "Friction (0 -" type:#integer range:[-10000,10000,20] toolTip:"Friction (0 - 100 percent): The amount of rotational friction. Value must be between 0 and 100  percent."
label wwmt_message_ui_label "Rotating sound WAV"  toolTip:"Rotating sound WAV: Sound to play while rotating."
editText wwmt_message_ui "" type:#string toolTip:"Rotating sound WAV: Sound to play while rotating."
spinner wwmt_volume_ui "Volume (10 = " type:#integer range:[-10000,10000,10] toolTip:"Volume (10 = loudest): The volume of the rotation sound."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
spinner wwmt_dmg_ui "Blocking Dama" type:#integer range:[-10000,10000,0] toolTip:"Blocking Damage: Damage done to any entity that blocks the rotation, per frame."
dropdownlist wwmt_solidbsp_ui "Solid Type" type:#string items:#("VPhysics","BSP")
on wwmt_solidbsp_ui selected i do solidbsp = propMapsolidbsp[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Start ON" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Reverse Direction" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "X Axis" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Y Axis" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Acc/Dcc" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Fan Pain" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Not Solid" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Small Sound Radius" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Medium Sound Radius" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Large Sound Radius" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_rotating" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_rotating_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rotating&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_rotating" address:"https://developer.valvesoftware.com/wiki/func_rotating?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if solidbsp != undefined AND findItem propMapsolidbsp solidbsp == 0 then (
 append propMapsolidbsp solidbsp
tmp = wwmt_solidbsp_ui.items
 append tmp solidbsp
wwmt_solidbsp_ui.items = tmp
wwmt_solidbsp_ui.selection = propMapsolidbsp.count
) else ( 
 if solidbsp != undefined then (
wwmt_solidbsp_ui.selection = (findItem propMapsolidbsp solidbsp)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_platrot_CA = attributes "WW Entity func_platrot" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_platrot"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","GoDown","GoUp","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("noise1","noise2","speed","height","rotation","_minlight","targetname","parentname","origin","angles","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
noise1 type:#string ui:wwmt_noise1_ui default:""
noise2 type:#string ui:wwmt_noise2_ui default:""
speed type:#integer ui:wwmt_speed_ui default:50
height type:#integer ui:wwmt_height_ui default:0
rotation type:#integer ui:wwmt_rotation_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_platrot"
label wwmt_noise1_ui_label "Movement Sound"  toolTip:"Movement Sound: The sound to play when the brush moves."
editText wwmt_noise1_ui "" type:#string toolTip:"Movement Sound: The sound to play when the brush moves."
label wwmt_noise2_ui_label "Stop Sound"  toolTip:"Stop Sound: The sound to play when the brush stops moving."
editText wwmt_noise2_ui "" type:#string toolTip:"Stop Sound: The sound to play when the brush stops moving."
spinner wwmt_speed_ui "Speed of Rota" type:#integer range:[-10000,10000,50] toolTip:"Speed of Rotation: Speed at which the brush rotates, in degrees per second."
spinner wwmt_height_ui "Travel Altitu" type:#integer range:[-10000,10000,0] toolTip:"Travel Altitude: The vertical distance from the starting position that this platform moves. If negative, the platform will lower."
spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000,10000,0] toolTip:"Spin amount: The amount this platform should rotate as it moves, in degrees."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Toggle" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_platrot" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_platrot_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_platrot&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_platrot" address:"https://developer.valvesoftware.com/wiki/func_platrot?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_button_CA = attributes "WW Entity func_button" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_button"
local hasOutputs = true
local availableOutputs=#("OnDamaged","OnIn","OnOut","OnPressed","OnUseLocked","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Lock","Press","PressIn","PressOut","SetDamageFilter","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Unlock")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","31","32","33","34","35","36","37","40","41","42","43","44","45","46","47")
local propVallocked_sound="0"
local propMaplocked_sound=#("0","2","8","10","11","12")
local propValunlocked_sound="0"
local propMapunlocked_sound=#("0","1","3","4","5","6","7","8","9","10","13","14")
local propVallocked_sentence="0"
local propMaplocked_sentence=#("0","1","2","3","4","5","6","7","8","9")
local propValunlocked_sentence="0"
local propMapunlocked_sentence=#("0","1","2","3","4","5","6","7","8")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("movedir","speed","health","lip","master","sounds","wait","locked_sound","unlocked_sound","locked_sentence","unlocked_sentence","_minlight","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","damagefilter")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
movedir type:#string ui:wwmt_movedir_ui default:"0 0 0"
speed type:#integer ui:wwmt_speed_ui default:5
health type:#integer ui:wwmt_health_ui default:0
lip type:#integer ui:wwmt_lip_ui default:0
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
wait type:#integer ui:wwmt_wait_ui default:3
locked_sound type:#string ui:wwmt_locked_sound_ui default:"0"
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:"0"
locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
damagefilter type:#string ui:wwmt_damagefilter_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_button"
label wwmt_movedir_ui_label "Move Direction (Pitch Yaw Roll)"  toolTip:"Move Direction (Pitch Yaw Roll): Specifies the direction of motion to move when the button is used."
editText wwmt_movedir_ui "" type:#string toolTip:"Move Direction (Pitch Yaw Roll): Specifies the direction of motion to move when the button is used."
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,5] toolTip:"Speed: The speed that the button moves, in inches per second."
spinner wwmt_health_ui "Health (Obsol" type:#integer range:[-10000,10000,0] toolTip:"Health (Obsolete): Legacy method of specifying whether or not the button can be shot to activate it. Use the 'Damage Activates' spawnflag instead."
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0] toolTip:"Lip: The amount, in inches, of the button to leave sticking out of the wall it recedes into when pressed. Negative values make the button recede even further into the wall."
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be pressed."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be pressed."
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("None (Silent)","Big zap & Warmup","Access Denied","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Buzz Off","latch locked","Latch Unlocked","Lightswitch","small bleek","small deny","small doop","small tech deny","click and combine screen fuzz","roomy beep","lever or wheel","lever or wheel","lever or wheel","lever or wheel","lever or wheel","lever or wheel","lever or wheel","lever or wheel","shock buzz","clickbeep","tech blip","clickbeepbeep open","small high blip","small tech fuzz blip","small click bleep (change to lightswitch)","combine door lock - locked","combine blip growl","combine squick growl","combine whine purr","combine click talk","combine click growl fizz","combine click fizz (deny)","combine click talker")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
spinner wwmt_wait_ui "Delay Before " type:#integer range:[-10000,10000,3] toolTip:"Delay Before Reset (-1 stay): Amount of time, in seconds, after the button has been pressed before it returns to the starting position. Once it has returned, it can be used again. If the value is set to -1, the button never returns."
dropdownlist wwmt_locked_sound_ui "Locked Sound" type:#string items:#("None","Access Denied","Small zap","Buzz","Buzz Off","Latch Locked") toolTip:"Locked Sound: Sound played when the player tries to use the button, and fails because it's locked. ="
on wwmt_locked_sound_ui selected i do locked_sound = propMaplocked_sound[i] 
dropdownlist wwmt_unlocked_sound_ui "Unlocked Sound" type:#string items:#("None","Big zap & Warmup","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Buzz","Latch Unlocked","Lightswitch") toolTip:"Unlocked Sound: Sound played when the button is unlocked. ="
on wwmt_unlocked_sound_ui selected i do unlocked_sound = propMapunlocked_sound[i] 
dropdownlist wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None","Gen. Access Denied","Security Lockout","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance Door","Broken Shut Door") toolTip:"Locked Sentence: A sentence played when the player tries to use the button, and fails because it's locked. ="
on wwmt_locked_sentence_ui selected i do locked_sentence = propMaplocked_sentence[i] 
dropdownlist wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None","Gen. Access Granted","Security Disengaged","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance area") toolTip:"Unlocked Sentence: A sentence played when the button is unlocked. ="
on wwmt_unlocked_sentence_ui selected i do unlocked_sentence = propMapunlocked_sentence[i] 
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_damagefilter_ui_label "Damage Filter"  toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
editText wwmt_damagefilter_ui "" type:#string toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
pickbutton wwmt_damagefilter_pickme_ui "Pick Damage Filter" message:"Pick Target Entity for Damage Filter" filter:target_name_filter 
on wwmt_damagefilter_pickme_ui picked obj do (
damagefilter = obj.targetname
) 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
if params.flag_4096_ui.checked == true then (
sfs+=4096
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Don't move" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Touch Activates" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Damage Activates" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Use Activates" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Starts locked" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
checkbox flag_4096_ui "Sparks" type:#integer

on flag_4096_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_button" address:"https://developer.valvesoftware.com/wiki/func_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if locked_sound != undefined AND findItem propMaplocked_sound locked_sound == 0 then (
 append propMaplocked_sound locked_sound
tmp = wwmt_locked_sound_ui.items
 append tmp locked_sound
wwmt_locked_sound_ui.items = tmp
wwmt_locked_sound_ui.selection = propMaplocked_sound.count
) else ( 
 if locked_sound != undefined then (
wwmt_locked_sound_ui.selection = (findItem propMaplocked_sound locked_sound)
)
)
 if unlocked_sound != undefined AND findItem propMapunlocked_sound unlocked_sound == 0 then (
 append propMapunlocked_sound unlocked_sound
tmp = wwmt_unlocked_sound_ui.items
 append tmp unlocked_sound
wwmt_unlocked_sound_ui.items = tmp
wwmt_unlocked_sound_ui.selection = propMapunlocked_sound.count
) else ( 
 if unlocked_sound != undefined then (
wwmt_unlocked_sound_ui.selection = (findItem propMapunlocked_sound unlocked_sound)
)
)
 if locked_sentence != undefined AND findItem propMaplocked_sentence locked_sentence == 0 then (
 append propMaplocked_sentence locked_sentence
tmp = wwmt_locked_sentence_ui.items
 append tmp locked_sentence
wwmt_locked_sentence_ui.items = tmp
wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
) else ( 
 if locked_sentence != undefined then (
wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
)
)
 if unlocked_sentence != undefined AND findItem propMapunlocked_sentence unlocked_sentence == 0 then (
 append propMapunlocked_sentence unlocked_sentence
tmp = wwmt_unlocked_sentence_ui.items
 append tmp unlocked_sentence
wwmt_unlocked_sentence_ui.items = tmp
wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
) else ( 
 if unlocked_sentence != undefined then (
wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4096 == 4096 then (
flag_4096_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_rot_button_CA = attributes "WW Entity func_rot_button" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_rot_button"
local hasOutputs = true
local availableOutputs=#("OnDamaged","OnIn","OnOut","OnPressed","OnUseLocked","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Lock","Press","PressIn","PressOut","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Unlock")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="21"
local propMapsounds=#("0","21","22","23","24","25")
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("master","speed","health","sounds","wait","distance","_minlight","targetname","parentname","origin","angles","globalname","startdisabled")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
speed type:#integer ui:wwmt_speed_ui default:50
health type:#integer ui:wwmt_health_ui default:0
sounds type:#string ui:wwmt_sounds_ui default:"21"
wait type:#integer ui:wwmt_wait_ui default:3
distance type:#integer ui:wwmt_distance_ui default:90
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
globalname type:#string ui:wwmt_globalname_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_rot_button"
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,50] toolTip:"Speed: The speed that the button rotates, in degrees per second."
spinner wwmt_health_ui "Health (Obsol" type:#integer range:[-10000,10000,0] toolTip:"Health (Obsolete): Legacy method of specifying whether or not the button can be shot to activate it. Use the 'Damage Activates' spawnflag instead."
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("None (Silent)","Squeaky","Squeaky Pneumatic","Ratchet Groan","Clean Ratchet","Gas Clunk")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
spinner wwmt_wait_ui "Delay Before " type:#integer range:[-10000,10000,3] toolTip:"Delay Before Reset (-1 stay): Amount of time, in seconds, after the button has been pressed before it returns to the starting position. Once it has returned, it can be used again. If the value is set to -1, the button never returns."
spinner wwmt_distance_ui "Distance (deg" type:#integer range:[-10000,10000,90] toolTip:"Distance (deg): The amount, in degrees, that the button should rotate when it's pressed."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Not solid" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Reverse Dir" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Touch Activates" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Damage Activates" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Use Activates" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Starts locked" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_rot_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_rot_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_rot_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_rot_button" address:"https://developer.valvesoftware.com/wiki/func_rot_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_momentary_rot_button_CA = attributes "WW Entity momentary_rot_button" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="momentary_rot_button"
local hasOutputs = true
local availableOutputs=#("OnFullyClosed","OnFullyOpen","OnPressed","OnReachedPosition","OnUnpressed","OnUser1","OnUser2","OnUser3","OnUser4","Position")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Lock","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetPosition","SetPositionImmediately","Unlock")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsounds="0"
local propMapsounds=#("0","1","2","3","4","5","6","7","8","9","21","22","23","24","25")
local propValstartdirection="-1"
local propMapstartdirection=#("-1","1")
local propValsolidbsp="0"
local propMapsolidbsp=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("speed","master","sounds","distance","returnspeed","_minlight","startposition","startdirection","solidbsp","targetname","parentname","origin","angles","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:50
master type:#string ui:wwmt_master_ui default:""
sounds type:#string ui:wwmt_sounds_ui default:"0"
distance type:#integer ui:wwmt_distance_ui default:90
returnspeed type:#integer ui:wwmt_returnspeed_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
startposition type:#float ui:wwmt_startposition_ui default:0
startdirection type:#string ui:wwmt_startdirection_ui default:"-1"
solidbsp type:#string ui:wwmt_solidbsp_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "momentary_rot_button"
spinner wwmt_speed_ui "Speed (deg/se" type:#integer range:[-10000,10000,50] toolTip:"Speed (deg/sec): The amount, in degrees, that the wheel turns per second."
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
dropdownlist wwmt_sounds_ui "Sounds" type:#string items:#("None","Big zap & Warmup","Access Denied","Access Granted","Quick Combolock","Power Deadbolt 1","Power Deadbolt 2","Plunger","Small zap","Keycard Sound","Squeaky","Squeaky Pneumatic","Ratchet Groan","Clean Ratchet","Gas Clunk")
on wwmt_sounds_ui selected i do sounds = propMapsounds[i] 
spinner wwmt_distance_ui "Distance" type:#integer range:[-10000,10000,90] toolTip:"Distance: The maximum amount, in degrees, that the wheel is allowed to rotate."
spinner wwmt_returnspeed_ui "Auto-return s" type:#integer range:[-10000,10000,0] toolTip:"Auto-return speed: If the 'Toggle' spawnflag is not set, the speed at which the wheel auto-returns when left alone, in degrees per second."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
spinner wwmt_startposition_ui "Start Positio" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Start Position: Postion when spawned. The value is a range between 0.0 and 1.0, where 0 is the unrotated position and 1 is the rotated position + 'Distance'."
dropdownlist wwmt_startdirection_ui "Start Direction" type:#string items:#("Forward","Backward")
on wwmt_startdirection_ui selected i do startdirection = propMapstartdirection[i] 
dropdownlist wwmt_solidbsp_ui "Solid BSP" type:#string items:#("No","Yes")
on wwmt_solidbsp_ui selected i do solidbsp = propMapsolidbsp[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
if params.flag_8192_ui.checked == true then (
sfs+=8192
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Not Solid" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle (Disable Auto Return)" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Use Activates" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Starts locked" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
checkbox flag_8192_ui "Jiggle when used while locked" type:#integer

on flag_8192_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with momentary_rot_button" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"momentary_rot_button_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=momentary_rot_button&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: momentary_rot_button" address:"https://developer.valvesoftware.com/wiki/momentary_rot_button?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if sounds != undefined AND findItem propMapsounds sounds == 0 then (
 append propMapsounds sounds
tmp = wwmt_sounds_ui.items
 append tmp sounds
wwmt_sounds_ui.items = tmp
wwmt_sounds_ui.selection = propMapsounds.count
) else ( 
 if sounds != undefined then (
wwmt_sounds_ui.selection = (findItem propMapsounds sounds)
)
)
 if startdirection != undefined AND findItem propMapstartdirection startdirection == 0 then (
 append propMapstartdirection startdirection
tmp = wwmt_startdirection_ui.items
 append tmp startdirection
wwmt_startdirection_ui.items = tmp
wwmt_startdirection_ui.selection = propMapstartdirection.count
) else ( 
 if startdirection != undefined then (
wwmt_startdirection_ui.selection = (findItem propMapstartdirection startdirection)
)
)
 if solidbsp != undefined AND findItem propMapsolidbsp solidbsp == 0 then (
 append propMapsolidbsp solidbsp
tmp = wwmt_solidbsp_ui.items
 append tmp solidbsp
wwmt_solidbsp_ui.items = tmp
wwmt_solidbsp_ui.selection = propMapsolidbsp.count
) else ( 
 if solidbsp != undefined then (
wwmt_solidbsp_ui.selection = (findItem propMapsolidbsp solidbsp)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8192 == 8192 then (
flag_8192_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_door_CA = attributes "WW Entity func_door" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_door"
local hasOutputs = true
local availableOutputs=#("OnBlockedClosing","OnBlockedOpening","OnClose","OnFullyClosed","OnFullyOpen","OnLockedUse","OnOpen","OnUnblockedClosing","OnUnblockedOpening","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Close","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Lock","Open","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","Toggle","Unlock")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValforceclosed="0"
local propMapforceclosed=#("0","1")
local propValignoredebris="0"
local propMapignoredebris=#("0","1")
local propValspawnpos="0"
local propMapspawnpos=#("0","1")
local propVallocked_sentence="0"
local propMaplocked_sentence=#("0","1","2","3","4","5","6","7","8","9")
local propValunlocked_sentence="0"
local propMapunlocked_sentence=#("0","1","2","3","4","5","6","7","8")
local propValloopmovesound="0"
local propMaploopmovesound=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("movedir","filtername","speed","master","noise1","noise2","startclosesound","closesound","wait","lip","dmg","forceclosed","ignoredebris","message","health","locked_sound","unlocked_sound","spawnpos","locked_sentence","unlocked_sentence","_minlight","loopmovesound","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows","origin")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
movedir type:#string ui:wwmt_movedir_ui default:"0 0 0"
filtername type:#string ui:wwmt_filtername_ui default:""
speed type:#integer ui:wwmt_speed_ui default:100
master type:#string ui:wwmt_master_ui default:""
noise1 type:#string ui:wwmt_noise1_ui default:""
noise2 type:#string ui:wwmt_noise2_ui default:""
startclosesound type:#string ui:wwmt_startclosesound_ui default:""
closesound type:#string ui:wwmt_closesound_ui default:""
wait type:#integer ui:wwmt_wait_ui default:4
lip type:#integer ui:wwmt_lip_ui default:0
dmg type:#integer ui:wwmt_dmg_ui default:0
forceclosed type:#string ui:wwmt_forceclosed_ui default:"0"
ignoredebris type:#string ui:wwmt_ignoredebris_ui default:"0"
message type:#string ui:wwmt_message_ui default:"Looks like this was removed"
health type:#integer ui:wwmt_health_ui default:0
locked_sound type:#string ui:wwmt_locked_sound_ui default:""
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:""
spawnpos type:#string ui:wwmt_spawnpos_ui default:"0"
locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
loopmovesound type:#string ui:wwmt_loopmovesound_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
origin type:#string ui:wwmt_origin_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_door"
label wwmt_movedir_ui_label "Move Direction (Pitch Yaw Roll)"  toolTip:"Move Direction (Pitch Yaw Roll): The direction the door will move, when it opens."
editText wwmt_movedir_ui "" type:#string toolTip:"Move Direction (Pitch Yaw Roll): The direction the door will move, when it opens."
label wwmt_filtername_ui_label "Block Filter Name"  toolTip:"Block Filter Name: Source port only )"
editText wwmt_filtername_ui "" type:#string toolTip:"Block Filter Name: Source port only )"
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100] toolTip:"Speed: The speed at which the door moves."
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
label wwmt_noise1_ui_label "Start Sound"  toolTip:"Start Sound: Sound to play when the door starts moving."
editText wwmt_noise1_ui "" type:#string toolTip:"Start Sound: Sound to play when the door starts moving."
label wwmt_noise2_ui_label "Stop Sound"  toolTip:"Stop Sound: Sound to play when the door stops moving."
editText wwmt_noise2_ui "" type:#string toolTip:"Stop Sound: Sound to play when the door stops moving."
label wwmt_startclosesound_ui_label "Start Close Sound"  toolTip:"Start Close Sound: (Optional) Sound to play when the door starts closing."
editText wwmt_startclosesound_ui "" type:#string toolTip:"Start Close Sound: (Optional) Sound to play when the door starts closing."
label wwmt_closesound_ui_label "Stop Close Sound"  toolTip:"Stop Close Sound: (Optional) Sound to play when the door stops closing."
editText wwmt_closesound_ui "" type:#string toolTip:"Stop Close Sound: (Optional) Sound to play when the door stops closing."
spinner wwmt_wait_ui "Delay Before " type:#integer range:[-10000,10000,4] toolTip:"Delay Before Reset (-1 stay): Amount of time, in seconds, after the door has opened before it closes. Once it has closed, it can be used again. If the value is set to -1, the door never closes itself."
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0] toolTip:"Lip: The amount, in inches, of the button to leave sticking out of the wall it recedes into when pressed. Negative values make the button recede even further into the wall."
spinner wwmt_dmg_ui "Blocking Dama" type:#integer range:[-10000,10000,0] toolTip:"Blocking Damage: Amount of damage done to entities that block the movement of this door, per frame."
dropdownlist wwmt_forceclosed_ui "Force Closed" type:#string items:#("No","Yes") toolTip:"Force Closed: If set, this door will close no matter what. Useful for doors that have to close even if the player tries to block them with objects. ="
on wwmt_forceclosed_ui selected i do forceclosed = propMapforceclosed[i] 
dropdownlist wwmt_ignoredebris_ui "Ignore Debris" type:#string items:#("No","Yes") toolTip:"Ignore Debris: If set this will change the door's collision group to one that ignore collisions with debris objects (note that this is not compatible with the non-solid-to-player spawnflag). ="
on wwmt_ignoredebris_ui selected i do ignoredebris = propMapignoredebris[i] 
label wwmt_message_ui_label "Message If Triggered // NEEDHELP" 
editText wwmt_message_ui "" type:#string
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0] toolTip:"Health (shoot open): Looks like this was removed"
label wwmt_locked_sound_ui_label "Locked Sound"  toolTip:"Locked Sound: Sound played when the player tries to use the door, and fails because it's locked."
editText wwmt_locked_sound_ui "" type:#string toolTip:"Locked Sound: Sound played when the player tries to use the door, and fails because it's locked."
label wwmt_unlocked_sound_ui_label "Unlocked Sound"  toolTip:"Unlocked Sound: Sound played when the button is door."
editText wwmt_unlocked_sound_ui "" type:#string toolTip:"Unlocked Sound: Sound played when the button is door."
dropdownlist wwmt_spawnpos_ui "Spawn Position" type:#string items:#("Closed","Open")
on wwmt_spawnpos_ui selected i do spawnpos = propMapspawnpos[i] 
dropdownlist wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None","Gen. Access Denied","Security Lockout","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance Door","Broken Shut Door") toolTip:"Locked Sentence: A sentence played when the player tries to use the door, and fails because it's locked. ="
on wwmt_locked_sentence_ui selected i do locked_sentence = propMaplocked_sentence[i] 
dropdownlist wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None","Gen. Access Granted","Security Disengaged","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance area") toolTip:"Unlocked Sentence: A sentence played when the door is unlocked. ="
on wwmt_unlocked_sentence_ui selected i do unlocked_sentence = propMapunlocked_sentence[i] 
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
dropdownlist wwmt_loopmovesound_ui "Loop Moving Sound?" type:#string items:#("No","Yes") toolTip:"Loop Moving Sound?: If set to true, the door's 'Start Sound' will be continually looped until the door finishes moving. ="
on wwmt_loopmovesound_ui selected i do loopmovesound = propMaploopmovesound[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
if params.flag_4096_ui.checked == true then (
sfs+=4096
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Starts Open - OBSOLETE, use 'Spawn Position' key instead" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Non-solid to Player" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Opens" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "NPCs Can't" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Touch Opens" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Starts locked" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
checkbox flag_4096_ui "Door Silent" type:#integer

on flag_4096_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_door" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_door_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_door" address:"https://developer.valvesoftware.com/wiki/func_door?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if forceclosed != undefined AND findItem propMapforceclosed forceclosed == 0 then (
 append propMapforceclosed forceclosed
tmp = wwmt_forceclosed_ui.items
 append tmp forceclosed
wwmt_forceclosed_ui.items = tmp
wwmt_forceclosed_ui.selection = propMapforceclosed.count
) else ( 
 if forceclosed != undefined then (
wwmt_forceclosed_ui.selection = (findItem propMapforceclosed forceclosed)
)
)
 if ignoredebris != undefined AND findItem propMapignoredebris ignoredebris == 0 then (
 append propMapignoredebris ignoredebris
tmp = wwmt_ignoredebris_ui.items
 append tmp ignoredebris
wwmt_ignoredebris_ui.items = tmp
wwmt_ignoredebris_ui.selection = propMapignoredebris.count
) else ( 
 if ignoredebris != undefined then (
wwmt_ignoredebris_ui.selection = (findItem propMapignoredebris ignoredebris)
)
)
 if spawnpos != undefined AND findItem propMapspawnpos spawnpos == 0 then (
 append propMapspawnpos spawnpos
tmp = wwmt_spawnpos_ui.items
 append tmp spawnpos
wwmt_spawnpos_ui.items = tmp
wwmt_spawnpos_ui.selection = propMapspawnpos.count
) else ( 
 if spawnpos != undefined then (
wwmt_spawnpos_ui.selection = (findItem propMapspawnpos spawnpos)
)
)
 if locked_sentence != undefined AND findItem propMaplocked_sentence locked_sentence == 0 then (
 append propMaplocked_sentence locked_sentence
tmp = wwmt_locked_sentence_ui.items
 append tmp locked_sentence
wwmt_locked_sentence_ui.items = tmp
wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
) else ( 
 if locked_sentence != undefined then (
wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
)
)
 if unlocked_sentence != undefined AND findItem propMapunlocked_sentence unlocked_sentence == 0 then (
 append propMapunlocked_sentence unlocked_sentence
tmp = wwmt_unlocked_sentence_ui.items
 append tmp unlocked_sentence
wwmt_unlocked_sentence_ui.items = tmp
wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
) else ( 
 if unlocked_sentence != undefined then (
wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
)
)
 if loopmovesound != undefined AND findItem propMaploopmovesound loopmovesound == 0 then (
 append propMaploopmovesound loopmovesound
tmp = wwmt_loopmovesound_ui.items
 append tmp loopmovesound
wwmt_loopmovesound_ui.items = tmp
wwmt_loopmovesound_ui.selection = propMaploopmovesound.count
) else ( 
 if loopmovesound != undefined then (
wwmt_loopmovesound_ui.selection = (findItem propMaploopmovesound loopmovesound)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4096 == 4096 then (
flag_4096_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_door_rotating_CA = attributes "WW Entity func_door_rotating" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_door_rotating"
local hasOutputs = true
local availableOutputs=#("OnBlockedClosing","OnBlockedOpening","OnClose","OnFullyClosed","OnFullyOpen","OnLockedUse","OnOpen","OnUnblockedClosing","OnUnblockedOpening","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Close","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Lock","Open","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","Toggle","Unlock")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsolidbsp="0"
local propMapsolidbsp=#("0","1")
local propValforceclosed="0"
local propMapforceclosed=#("0","1")
local propValignoredebris="0"
local propMapignoredebris=#("0","1")
local propValspawnpos="0"
local propMapspawnpos=#("0","1")
local propVallocked_sentence="0"
local propMaplocked_sentence=#("0","1","2","3","4","5","6","7","8","9")
local propValunlocked_sentence="0"
local propMapunlocked_sentence=#("0","1","2","3","4","5","6","7","8")
local propValloopmovesound="0"
local propMaploopmovesound=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("distance","solidbsp","speed","master","noise1","noise2","startclosesound","closesound","wait","lip","dmg","forceclosed","ignoredebris","message","health","locked_sound","unlocked_sound","spawnpos","locked_sentence","unlocked_sentence","_minlight","loopmovesound","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows","origin","angles")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
distance type:#integer ui:wwmt_distance_ui default:90
solidbsp type:#string ui:wwmt_solidbsp_ui default:"0"
speed type:#integer ui:wwmt_speed_ui default:100
master type:#string ui:wwmt_master_ui default:""
noise1 type:#string ui:wwmt_noise1_ui default:""
noise2 type:#string ui:wwmt_noise2_ui default:""
startclosesound type:#string ui:wwmt_startclosesound_ui default:""
closesound type:#string ui:wwmt_closesound_ui default:""
wait type:#integer ui:wwmt_wait_ui default:4
lip type:#integer ui:wwmt_lip_ui default:0
dmg type:#integer ui:wwmt_dmg_ui default:0
forceclosed type:#string ui:wwmt_forceclosed_ui default:"0"
ignoredebris type:#string ui:wwmt_ignoredebris_ui default:"0"
message type:#string ui:wwmt_message_ui default:"Looks like this was removed"
health type:#integer ui:wwmt_health_ui default:0
locked_sound type:#string ui:wwmt_locked_sound_ui default:""
unlocked_sound type:#string ui:wwmt_unlocked_sound_ui default:""
spawnpos type:#string ui:wwmt_spawnpos_ui default:"0"
locked_sentence type:#string ui:wwmt_locked_sentence_ui default:"0"
unlocked_sentence type:#string ui:wwmt_unlocked_sentence_ui default:"0"
_minlight type:#string ui:wwmt__minlight_ui default:""
loopmovesound type:#string ui:wwmt_loopmovesound_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_door_rotating"
spinner wwmt_distance_ui "Distance" type:#integer range:[-10000,10000,90] toolTip:"Distance: The amount, in degrees, that the button should rotate when it's pressed."
dropdownlist wwmt_solidbsp_ui "Solid Type" type:#string items:#("VPhysics","BSP")
on wwmt_solidbsp_ui selected i do solidbsp = propMapsolidbsp[i] 
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,100] toolTip:"Speed: The speed at which the door moves."
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this button cannot be used."
label wwmt_noise1_ui_label "Start Sound"  toolTip:"Start Sound: Sound to play when the door starts moving."
editText wwmt_noise1_ui "" type:#string toolTip:"Start Sound: Sound to play when the door starts moving."
label wwmt_noise2_ui_label "Stop Sound"  toolTip:"Stop Sound: Sound to play when the door stops moving."
editText wwmt_noise2_ui "" type:#string toolTip:"Stop Sound: Sound to play when the door stops moving."
label wwmt_startclosesound_ui_label "Start Close Sound"  toolTip:"Start Close Sound: (Optional) Sound to play when the door starts closing."
editText wwmt_startclosesound_ui "" type:#string toolTip:"Start Close Sound: (Optional) Sound to play when the door starts closing."
label wwmt_closesound_ui_label "Stop Close Sound"  toolTip:"Stop Close Sound: (Optional) Sound to play when the door stops closing."
editText wwmt_closesound_ui "" type:#string toolTip:"Stop Close Sound: (Optional) Sound to play when the door stops closing."
spinner wwmt_wait_ui "Delay Before " type:#integer range:[-10000,10000,4] toolTip:"Delay Before Reset (-1 stay): Amount of time, in seconds, after the door has opened before it closes. Once it has closed, it can be used again. If the value is set to -1, the door never closes itself."
spinner wwmt_lip_ui "Lip" type:#integer range:[-10000,10000,0] toolTip:"Lip: The amount, in inches, of the button to leave sticking out of the wall it recedes into when pressed. Negative values make the button recede even further into the wall."
spinner wwmt_dmg_ui "Blocking Dama" type:#integer range:[-10000,10000,0] toolTip:"Blocking Damage: Amount of damage done to entities that block the movement of this door, per frame."
dropdownlist wwmt_forceclosed_ui "Force Closed" type:#string items:#("No","Yes") toolTip:"Force Closed: If set, this door will close no matter what. Useful for doors that have to close even if the player tries to block them with objects. ="
on wwmt_forceclosed_ui selected i do forceclosed = propMapforceclosed[i] 
dropdownlist wwmt_ignoredebris_ui "Ignore Debris" type:#string items:#("No","Yes") toolTip:"Ignore Debris: If set this will change the door's collision group to one that ignore collisions with debris objects (note that this is not compatible with the non-solid-to-player spawnflag). ="
on wwmt_ignoredebris_ui selected i do ignoredebris = propMapignoredebris[i] 
label wwmt_message_ui_label "Message If Triggered // NEEDHELP" 
editText wwmt_message_ui "" type:#string
spinner wwmt_health_ui "Health (shoot" type:#integer range:[-10000,10000,0] toolTip:"Health (shoot open): Looks like this was removed"
label wwmt_locked_sound_ui_label "Locked Sound"  toolTip:"Locked Sound: Sound played when the player tries to use the door, and fails because it's locked."
editText wwmt_locked_sound_ui "" type:#string toolTip:"Locked Sound: Sound played when the player tries to use the door, and fails because it's locked."
label wwmt_unlocked_sound_ui_label "Unlocked Sound"  toolTip:"Unlocked Sound: Sound played when the button is door."
editText wwmt_unlocked_sound_ui "" type:#string toolTip:"Unlocked Sound: Sound played when the button is door."
dropdownlist wwmt_spawnpos_ui "Spawn Position" type:#string items:#("Closed","Open")
on wwmt_spawnpos_ui selected i do spawnpos = propMapspawnpos[i] 
dropdownlist wwmt_locked_sentence_ui "Locked Sentence" type:#string items:#("None","Gen. Access Denied","Security Lockout","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance Door","Broken Shut Door") toolTip:"Locked Sentence: A sentence played when the player tries to use the door, and fails because it's locked. ="
on wwmt_locked_sentence_ui selected i do locked_sentence = propMaplocked_sentence[i] 
dropdownlist wwmt_unlocked_sentence_ui "Unlocked Sentence" type:#string items:#("None","Gen. Access Granted","Security Disengaged","Blast Door","Fire Door","Chemical Door","Radiation Door","Gen. Containment","Maintenance area") toolTip:"Unlocked Sentence: A sentence played when the door is unlocked. ="
on wwmt_unlocked_sentence_ui selected i do unlocked_sentence = propMapunlocked_sentence[i] 
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
dropdownlist wwmt_loopmovesound_ui "Loop Moving Sound?" type:#string items:#("No","Yes") toolTip:"Loop Moving Sound?: If set to true, the door's 'Start Sound' will be continually looped until the door finishes moving. ="
on wwmt_loopmovesound_ui selected i do loopmovesound = propMaploopmovesound[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_65536_ui.checked == true then (
sfs+=65536
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
if params.flag_4096_ui.checked == true then (
sfs+=4096
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "Reverse Dir" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "One-way" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_65536_ui "New func_door +USE rules (NOT for prop_doors!!)" type:#integer

on flag_65536_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Starts Open - OBSOLETE, use 'Spawn Position' key instead" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Non-solid to Player" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Toggle" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Opens" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "NPCs Can't" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Touch Opens" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Starts locked" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
checkbox flag_4096_ui "Door Silent" type:#integer

on flag_4096_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_door_rotating" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_door_rotating_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_door_rotating&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_door_rotating" address:"https://developer.valvesoftware.com/wiki/func_door_rotating?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if solidbsp != undefined AND findItem propMapsolidbsp solidbsp == 0 then (
 append propMapsolidbsp solidbsp
tmp = wwmt_solidbsp_ui.items
 append tmp solidbsp
wwmt_solidbsp_ui.items = tmp
wwmt_solidbsp_ui.selection = propMapsolidbsp.count
) else ( 
 if solidbsp != undefined then (
wwmt_solidbsp_ui.selection = (findItem propMapsolidbsp solidbsp)
)
)
 if forceclosed != undefined AND findItem propMapforceclosed forceclosed == 0 then (
 append propMapforceclosed forceclosed
tmp = wwmt_forceclosed_ui.items
 append tmp forceclosed
wwmt_forceclosed_ui.items = tmp
wwmt_forceclosed_ui.selection = propMapforceclosed.count
) else ( 
 if forceclosed != undefined then (
wwmt_forceclosed_ui.selection = (findItem propMapforceclosed forceclosed)
)
)
 if ignoredebris != undefined AND findItem propMapignoredebris ignoredebris == 0 then (
 append propMapignoredebris ignoredebris
tmp = wwmt_ignoredebris_ui.items
 append tmp ignoredebris
wwmt_ignoredebris_ui.items = tmp
wwmt_ignoredebris_ui.selection = propMapignoredebris.count
) else ( 
 if ignoredebris != undefined then (
wwmt_ignoredebris_ui.selection = (findItem propMapignoredebris ignoredebris)
)
)
 if spawnpos != undefined AND findItem propMapspawnpos spawnpos == 0 then (
 append propMapspawnpos spawnpos
tmp = wwmt_spawnpos_ui.items
 append tmp spawnpos
wwmt_spawnpos_ui.items = tmp
wwmt_spawnpos_ui.selection = propMapspawnpos.count
) else ( 
 if spawnpos != undefined then (
wwmt_spawnpos_ui.selection = (findItem propMapspawnpos spawnpos)
)
)
 if locked_sentence != undefined AND findItem propMaplocked_sentence locked_sentence == 0 then (
 append propMaplocked_sentence locked_sentence
tmp = wwmt_locked_sentence_ui.items
 append tmp locked_sentence
wwmt_locked_sentence_ui.items = tmp
wwmt_locked_sentence_ui.selection = propMaplocked_sentence.count
) else ( 
 if locked_sentence != undefined then (
wwmt_locked_sentence_ui.selection = (findItem propMaplocked_sentence locked_sentence)
)
)
 if unlocked_sentence != undefined AND findItem propMapunlocked_sentence unlocked_sentence == 0 then (
 append propMapunlocked_sentence unlocked_sentence
tmp = wwmt_unlocked_sentence_ui.items
 append tmp unlocked_sentence
wwmt_unlocked_sentence_ui.items = tmp
wwmt_unlocked_sentence_ui.selection = propMapunlocked_sentence.count
) else ( 
 if unlocked_sentence != undefined then (
wwmt_unlocked_sentence_ui.selection = (findItem propMapunlocked_sentence unlocked_sentence)
)
)
 if loopmovesound != undefined AND findItem propMaploopmovesound loopmovesound == 0 then (
 append propMaploopmovesound loopmovesound
tmp = wwmt_loopmovesound_ui.items
 append tmp loopmovesound
wwmt_loopmovesound_ui.items = tmp
wwmt_loopmovesound_ui.selection = propMaploopmovesound.count
) else ( 
 if loopmovesound != undefined then (
wwmt_loopmovesound_ui.selection = (findItem propMaploopmovesound loopmovesound)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 65536 == 65536 then (
flag_65536_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4096 == 4096 then (
flag_4096_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_dustmotes_CA = attributes "WW Entity func_dustmotes" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_dustmotes"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","TurnOff","TurnOn")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local propValfrozen="0"
local propMapfrozen=#("0","1")
local exportProps=#("sizemin","sizemax","alpha","targetname","startdisabled","wwmt_color","spawnrate","speedmax","lifetimemin","lifetimemax","distmax","frozen")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
sizemin type:#string ui:wwmt_sizemin_ui default:"10"
sizemax type:#string ui:wwmt_sizemax_ui default:"20"
alpha type:#integer ui:wwmt_alpha_ui default:255
targetname type:#string ui:wwmt_targetname_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
wwmt_color type:#color ui:wwmt_color_ui default:( color 255 255 255 )
wwmt_color_intensity type:#integer ui:wwmt_color_inensity_ui default:20
spawnrate type:#integer ui:wwmt_spawnrate_ui default:40
speedmax type:#string ui:wwmt_speedmax_ui default:"13"
lifetimemin type:#string ui:wwmt_lifetimemin_ui default:"3"
lifetimemax type:#string ui:wwmt_lifetimemax_ui default:"5"
distmax type:#integer ui:wwmt_distmax_ui default:1024
frozen type:#string ui:wwmt_frozen_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_dustmotes"
label wwmt_sizemin_ui_label "Minimum Particle Size" 
editText wwmt_sizemin_ui "" type:#string
label wwmt_sizemax_ui_label "Maximum Particle Size" 
editText wwmt_sizemax_ui "" type:#string
spinner wwmt_alpha_ui "Alpha" type:#integer range:[-10000,10000,255]
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
colorPicker wwmt_color_ui "Particle Color (R G B)" color:( color 255 255 255 )
spinner wwmt_color_inensity_ui "Particle Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Particle Color (R G B)"
spinner wwmt_spawnrate_ui "Particle Per " type:#integer range:[-10000,10000,40] toolTip:"Particle Per Second: Number of particles to spawn, per second."
label wwmt_speedmax_ui_label "Maximum Particle Speed"  toolTip:"Maximum Particle Speed: Maximum speed that the particles can move after spawning."
editText wwmt_speedmax_ui "" type:#string toolTip:"Maximum Particle Speed: Maximum speed that the particles can move after spawning."
label wwmt_lifetimemin_ui_label "Minimum Particle Lifetime"  toolTip:"Minimum Particle Lifetime: Minimum number of seconds until each particle dies. Particles live for a random duration between this and 'Maximum Particle Lifetime'."
editText wwmt_lifetimemin_ui "" type:#string toolTip:"Minimum Particle Lifetime: Minimum number of seconds until each particle dies. Particles live for a random duration between this and 'Maximum Particle Lifetime'."
label wwmt_lifetimemax_ui_label "Maximum Particle Lifetime"  toolTip:"Maximum Particle Lifetime: Maximum number of seconds until each particle dies. Particles live for a random duration between 'Minimum Particle Lifetime' and this."
editText wwmt_lifetimemax_ui "" type:#string toolTip:"Maximum Particle Lifetime: Maximum number of seconds until each particle dies. Particles live for a random duration between 'Minimum Particle Lifetime' and this."
spinner wwmt_distmax_ui "Maximum Visib" type:#integer range:[-10000,10000,1024] toolTip:"Maximum Visible Distance: Maximum distance at which particles are visible. They fade to translucent at this distance."
dropdownlist wwmt_frozen_ui "Frozen" type:#string items:#("No","Yes") toolTip:"Frozen: When set, this entity spawns the number of particles in SpawnRate immediately, and then goes inactive. ="
on wwmt_frozen_ui selected i do frozen = propMapfrozen[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_dustmotes" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_dustmotes_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_dustmotes&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_dustmotes" address:"https://developer.valvesoftware.com/wiki/func_dustmotes?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
 if frozen != undefined AND findItem propMapfrozen frozen == 0 then (
 append propMapfrozen frozen
tmp = wwmt_frozen_ui.items
 append tmp frozen
wwmt_frozen_ui.items = tmp
wwmt_frozen_ui.selection = propMapfrozen.count
) else ( 
 if frozen != undefined then (
wwmt_frozen_ui.selection = (findItem propMapfrozen frozen)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_smokevolume_CA = attributes "WW Entity func_smokevolume" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_smokevolume"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetDensity","SetMovementSpeed","SetRotationSpeed")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("color1","color2","wwmt_material","particledrawwidth","particlespacingdistance","densityrampspeed","rotationspeed","movementspeed","density","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
color1 type:#color ui:wwmt_color1_ui default:( color 255 255 255 )
color1_intensity type:#integer ui:wwmt_color1_inensity_ui default:20
color2 type:#color ui:wwmt_color2_ui default:( color 255 255 255 )
color2_intensity type:#integer ui:wwmt_color2_inensity_ui default:20
wwmt_material type:#string ui:wwmt_material_ui default:"particle/particle_smokegrenade"
particledrawwidth type:#float ui:wwmt_particledrawwidth_ui default:120
particlespacingdistance type:#float ui:wwmt_particlespacingdistance_ui default:80
densityrampspeed type:#float ui:wwmt_densityrampspeed_ui default:1
rotationspeed type:#float ui:wwmt_rotationspeed_ui default:10
movementspeed type:#float ui:wwmt_movementspeed_ui default:10
density type:#float ui:wwmt_density_ui default:1
targetname type:#string ui:wwmt_targetname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_smokevolume"
colorPicker wwmt_color1_ui "Particle Color1 (R G B)" color:( color 255 255 255 )
spinner wwmt_color1_inensity_ui "Particle Color1 (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Particle Color1 (R G B)"
colorPicker wwmt_color2_ui "Particle Color2 (R G B)" color:( color 255 255 255 )
spinner wwmt_color2_inensity_ui "Particle Color2 (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Particle Color2 (R G B)"
label wwmt_material_ui_label "Material"  toolTip:"Material: The material to use for the particles"
editText wwmt_material_ui "" type:#string toolTip:"Material: The material to use for the particles"
materialButton wwmt_material_pickme_ui "Pick Material Material" tooltip:"Pick the material forMaterial"

					on wwmt_material_pickme_ui picked mat do (
						wwmt_material = mat.name
						getNode()
						if getFileNameType mat.name == "" then (
							wwmt_material = (wwmt_material+".vmt")
						)
						local userresponse = yesNoCancelBox "Press Yes to Apply this Material to this Entity; No to apply a copy (useful for Overlays) or Cancel to do leave current material on node."
						case userresponse of (
							#yes:(thisNode.mat = mat)
							#no:(
								thisNode.mat = copy mat
								thisNode.mat.name = uniquename mat.name
								if classof thisNode.mat == Standard AND thisNode.mat.diffusemap != undefined then (
									thisNode.mat.diffusemap = copy thisNode.mat.diffusemap
									thisNode.mat.diffusemap.name = mat.diffusemap.name
								)
							)
							#cancel:()
						)
					) 
					on wwmt_material_pickme_ui rightclick  do (
						getNode()
						if thisNode.mat != undefined AND ::wallworm_GetMaterialName != undefined then (
							wwmt_material = ::wallworm_GetMaterialName thisNode.mat
							if getFileNameType thisNode.mat.name == "" then (
								wwmt_material = (wwmt_material + ".vmt")
							)
						)
					)
					spinner wwmt_particledrawwidth_ui "Particle Draw" type:#float scale:0.001 range:[-10000.000,10000.000,120] toolTip:"Particle Draw Width (units): The size of the particles, in units/inches."
spinner wwmt_particlespacingdistance_ui "Particle Spac" type:#float scale:0.001 range:[-10000.000,10000.000,80] toolTip:"Particle Spacing Distance (units): The distance between the particles inside the volume. The lower the number, the denser the particles, and the more overdraw there will be. It is best to keep it as high as you can without it looking bad."
spinner wwmt_densityrampspeed_ui "Density Ramp " type:#float scale:0.001 range:[-10000.000,10000.000,1] toolTip:"Density Ramp Speed (seconds): Time to go from density 0 to density 1, in seconds."
spinner wwmt_rotationspeed_ui "Rotation Spee" type:#float scale:0.001 range:[-10000.000,10000.000,10] toolTip:"Rotation Speed (degrees/sec): The speed that the particles should rotate, in degrees per second."
spinner wwmt_movementspeed_ui "Movement Spee" type:#float scale:0.001 range:[-10000.000,10000.000,10] toolTip:"Movement Speed (units/sec): The speed that the particles should move around, in units/inches per second."
spinner wwmt_density_ui "Density [0..1" type:#float scale:0.001 range:[-10000.000,10000.000,1]
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Emissive" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_smokevolume" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_smokevolume_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_smokevolume&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_smokevolume" address:"https://developer.valvesoftware.com/wiki/func_smokevolume?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_dustcloud_CA = attributes "WW Entity func_dustcloud" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_dustcloud"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","TurnOff","TurnOn")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local propValfrozen="0"
local propMapfrozen=#("0","1")
local exportProps=#("alpha","sizemin","sizemax","targetname","startdisabled","wwmt_color","spawnrate","speedmax","lifetimemin","lifetimemax","distmax","frozen")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
alpha type:#integer ui:wwmt_alpha_ui default:30
sizemin type:#string ui:wwmt_sizemin_ui default:"100"
sizemax type:#string ui:wwmt_sizemax_ui default:"200"
targetname type:#string ui:wwmt_targetname_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
wwmt_color type:#color ui:wwmt_color_ui default:( color 255 255 255 )
wwmt_color_intensity type:#integer ui:wwmt_color_inensity_ui default:20
spawnrate type:#integer ui:wwmt_spawnrate_ui default:40
speedmax type:#string ui:wwmt_speedmax_ui default:"13"
lifetimemin type:#string ui:wwmt_lifetimemin_ui default:"3"
lifetimemax type:#string ui:wwmt_lifetimemax_ui default:"5"
distmax type:#integer ui:wwmt_distmax_ui default:1024
frozen type:#string ui:wwmt_frozen_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_dustcloud"
spinner wwmt_alpha_ui "Alpha" type:#integer range:[-10000,10000,30]
label wwmt_sizemin_ui_label "Minimum Particle Size" 
editText wwmt_sizemin_ui "" type:#string
label wwmt_sizemax_ui_label "Maximum Particle Size" 
editText wwmt_sizemax_ui "" type:#string
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
colorPicker wwmt_color_ui "Particle Color (R G B)" color:( color 255 255 255 )
spinner wwmt_color_inensity_ui "Particle Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Particle Color (R G B)"
spinner wwmt_spawnrate_ui "Particle Per " type:#integer range:[-10000,10000,40] toolTip:"Particle Per Second: Number of particles to spawn, per second."
label wwmt_speedmax_ui_label "Maximum Particle Speed"  toolTip:"Maximum Particle Speed: Maximum speed that the particles can move after spawning."
editText wwmt_speedmax_ui "" type:#string toolTip:"Maximum Particle Speed: Maximum speed that the particles can move after spawning."
label wwmt_lifetimemin_ui_label "Minimum Particle Lifetime"  toolTip:"Minimum Particle Lifetime: Minimum number of seconds until each particle dies. Particles live for a random duration between this and 'Maximum Particle Lifetime'."
editText wwmt_lifetimemin_ui "" type:#string toolTip:"Minimum Particle Lifetime: Minimum number of seconds until each particle dies. Particles live for a random duration between this and 'Maximum Particle Lifetime'."
label wwmt_lifetimemax_ui_label "Maximum Particle Lifetime"  toolTip:"Maximum Particle Lifetime: Maximum number of seconds until each particle dies. Particles live for a random duration between 'Minimum Particle Lifetime' and this."
editText wwmt_lifetimemax_ui "" type:#string toolTip:"Maximum Particle Lifetime: Maximum number of seconds until each particle dies. Particles live for a random duration between 'Minimum Particle Lifetime' and this."
spinner wwmt_distmax_ui "Maximum Visib" type:#integer range:[-10000,10000,1024] toolTip:"Maximum Visible Distance: Maximum distance at which particles are visible. They fade to translucent at this distance."
dropdownlist wwmt_frozen_ui "Frozen" type:#string items:#("No","Yes") toolTip:"Frozen: When set, this entity spawns the number of particles in SpawnRate immediately, and then goes inactive. ="
on wwmt_frozen_ui selected i do frozen = propMapfrozen[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_dustcloud" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_dustcloud_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_dustcloud&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_dustcloud" address:"https://developer.valvesoftware.com/wiki/func_dustcloud?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
 if frozen != undefined AND findItem propMapfrozen frozen == 0 then (
 append propMapfrozen frozen
tmp = wwmt_frozen_ui.items
 append tmp frozen
wwmt_frozen_ui.items = tmp
wwmt_frozen_ui.selection = propMapfrozen.count
) else ( 
 if frozen != undefined then (
wwmt_frozen_ui.selection = (findItem propMapfrozen frozen)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_physbox_CA = attributes "WW Entity func_physbox" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_physbox"
local hasOutputs = true
local availableOutputs=#("OnAwakened","OnBreak","OnDamaged","OnHealthChanged","OnMotionEnabled","OnPhysCannonAnimatePostStarted","OnPhysCannonAnimatePreStarted","OnPhysCannonAnimatePullStarted","OnPhysCannonDetach","OnPhysCannonPullAnimFinished","OnPhysGunDrop","OnPhysGunOnlyPickup","OnPhysGunPickup","OnPhysGunPunt","OnPlayerUse","OnTakeDamage","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddHealth","AddOutput","Alpha","Break","ClearParent","Color","DisableDamageForces","DisableMotion","DisablePhyscannonPickup","DisableShadow","EnableDamageForces","EnableMotion","EnablePhyscannonPickup","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","ForceDrop","Kill","KillHierarchy","RemoveHealth","SetDamageFilter","SetHealth","SetMass","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Sleep","Wake")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValdamagetype="0"
local propMapdamagetype=#("0","1")
local propValnotsolid="0"
local propMapnotsolid=#("0","1")
local propValpropdata="0"
local propMappropdata=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24")
local propValmaterial="0"
local propMapmaterial=#("0","1","2","3","4","5","6","7","8","// 9","10")
local propValexplosion="0"
local propMapexplosion=#("0","1","2")
local propValnodamageforces="0"
local propMapnodamageforces=#("0","1")
local propValspawnobject="0"
local propMapspawnobject=#("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26")
local propValperformancemode="0"
local propMapperformancemode=#("0","1","2","3")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("_minlight","damagetype","massscale","overridescript","damagetoenablemotion","forcetoenablemotion","health","preferredcarryangles","notsolid","propdata","wwmt_material","explosion","gibdir","nodamageforces","gibmodel","spawnobject","explodemagnitude","pressuredelay","explodedamage","exploderadius","performancemode","targetname","damagefilter","disableshadows","parentname","globalname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
damagetype type:#string ui:wwmt_damagetype_ui default:"0"
massscale type:#float ui:wwmt_massscale_ui default:0
overridescript type:#string ui:wwmt_overridescript_ui default:""
damagetoenablemotion type:#integer ui:wwmt_damagetoenablemotion_ui default:0
forcetoenablemotion type:#float ui:wwmt_forcetoenablemotion_ui default:0
health type:#integer ui:wwmt_health_ui default:0
preferredcarryangles type:#string ui:wwmt_preferredcarryangles_ui default:"0 0 0"
notsolid type:#string ui:wwmt_notsolid_ui default:"0"
propdata type:#string ui:wwmt_propdata_ui default:"0"
wwmt_material type:#string ui:wwmt_material_ui default:"0"
explosion type:#string ui:wwmt_explosion_ui default:"0"
gibdir type:#string ui:wwmt_gibdir_ui default:"0 0 0"
nodamageforces type:#string ui:wwmt_nodamageforces_ui default:"0"
gibmodel type:#string ui:wwmt_gibmodel_ui default:""
spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
pressuredelay type:#float ui:wwmt_pressuredelay_ui default:0
explodedamage type:#float ui:wwmt_explodedamage_ui default:0
exploderadius type:#float ui:wwmt_exploderadius_ui default:0
performancemode type:#string ui:wwmt_performancemode_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
damagefilter type:#string ui:wwmt_damagefilter_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
parentname type:#string ui:wwmt_parentname_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_physbox"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
dropdownlist wwmt_damagetype_ui "Impact Damage Type" type:#string items:#("Blunt","Sharp")
on wwmt_damagetype_ui selected i do damagetype = propMapdamagetype[i] 
spinner wwmt_massscale_ui "Mass Scale" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Mass Scale: A scale multiplier for the object's mass."
label wwmt_overridescript_ui_label "Override Parameters"  toolTip:"Override Parameters: A list of physics key/value pairs that are usually in a physics prop .qc file. Format is 'key,value,key,value,etc'."
editText wwmt_overridescript_ui "" type:#string toolTip:"Override Parameters: A list of physics key/value pairs that are usually in a physics prop .qc file. Format is 'key,value,key,value,etc'."
spinner wwmt_damagetoenablemotion_ui "Health Level " type:#integer range:[-10000,10000,0] toolTip:"Health Level to Override Motion: If specified, this object will start motion disabled. Once its health has dropped below this specified amount, it will enable motion."
spinner wwmt_forcetoenablemotion_ui "Physics Impac" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Physics Impact Force to Override Motion: If specified, this object will start motion disabled. Any impact that imparts a force greater than this value on the physbox will enable motion."
spinner wwmt_health_ui "Strength" type:#integer range:[-10000,10000,0] toolTip:"Strength: Number of points of damage to take before breaking. 0 means don't break."
label wwmt_preferredcarryangles_ui_label "Preferred Player-carry Angles"  toolTip:"Preferred Player-carry Angles: If the 'Use Preferred Carry Angles' spawnflag is set, this angle is the angle which the object should orient to when the player picks it up, with the physgun or +USE."
editText wwmt_preferredcarryangles_ui "" type:#string toolTip:"Preferred Player-carry Angles: If the 'Use Preferred Carry Angles' spawnflag is set, this angle is the angle which the object should orient to when the player picks it up, with the physgun or +USE."
dropdownlist wwmt_notsolid_ui "Not solid to world" type:#string items:#("Solid to World","Passes through World")
on wwmt_notsolid_ui selected i do notsolid = propMapnotsolid[i] 
dropdownlist wwmt_propdata_ui "Prop Data" type:#string items:#("None","Wooden.Tiny","Wooden.Small","Wooden.Medium","Wooden.Large","Wooden.Huge","Metal.Small","Metal.Medium","Metal.Large","Cardboard.Small","Cardboard.Medium","Cardboard.Large","Stone.Small","Stone.Medium","Stone.Large","Stone.Huge","Glass.Small","Plastic.Small","Plastic.Medium","Plastic.Large","Pottery.Small","Pottery.Medium","Pottery.Large","Pottery.Huge","Glass.Window") toolTip:"Prop Data: Set to the best approximation of the size and material of this entity's brushes. If set, it will override this entity's health and damage taken from various weapons. See the propdata.txt file in the scripts directory of your MOD to get a detailed list of what each entry specifies. ="
on wwmt_propdata_ui selected i do propdata = propMappropdata[i] 
dropdownlist wwmt_material_ui "Material Type" type:#string items:#("Glass","Wood","Metal","Flesh","CinderBlock","Ceiling Tile","Computer","Unbreakable Glass","Rocks","Web(defunct)","None") toolTip:"Material Type: Set to the material type of the brush. Used to decide what sounds to make when damaged, and what gibs to produce when broken. ="
on wwmt_material_ui selected i do wwmt_material = propMapmaterial[i] 
dropdownlist wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random","Relative to Attack","Use Precise Gib Dir") toolTip:"Gibs Direction: Used to decide which direction to throw gibs when broken. ="
on wwmt_explosion_ui selected i do explosion = propMapexplosion[i] 
label wwmt_gibdir_ui_label "Precise Gib Direction"  toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
editText wwmt_gibdir_ui "" type:#string toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
dropdownlist wwmt_nodamageforces_ui "Damaging it Doesn't Push It" type:#string items:#("No","Yes") toolTip:"Damaging it Doesn't Push It: Used to determine whether or not damage should cause the brush to move. ="
on wwmt_nodamageforces_ui selected i do nodamageforces = propMapnodamageforces[i] 
label wwmt_gibmodel_ui_label "Gib Model"  toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
editText wwmt_gibmodel_ui "" type:#string toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
dropdownlist wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("item_battery","item_healthkit","item_ammo_pistol","item_ammo_pistol_large","item_ammo_smg1","item_ammo_smg1_large","item_ammo_ar2","item_ammo_ar2_large","item_box_buckshot","item_flare_round","item_box_flare_rounds","item_ml_grenade","item_smg1_grenade","item_box_sniper_rounds","unused1","weapon_stunstick","weapon_ar1","weapon_ar2","unused2","weapon_ml","weapon_smg1","weapon_smg2","weapon_slam","weapon_shotgun","weapon_molotov","item_dynamic_resupply") toolTip:"Spawn On Break: When broken, an entity of the selected type will be created. ="
on wwmt_spawnobject_ui selected i do spawnobject = propMapspawnobject[i] 
spinner wwmt_explodemagnitude_ui "Explode Magni" type:#integer range:[-10000,10000,0] toolTip:"Explode Magnitude: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage."
spinner wwmt_pressuredelay_ui "Pressure Dela" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Pressure Delay: Delay, in seconds, after 'broken' by pressure before breaking apart (allows for sound to play before breaking apart)."
spinner wwmt_explodedamage_ui "Explosion Dam" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Damage: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage. See also 'Explosion Radius'."
spinner wwmt_exploderadius_ui "Explosion Rad" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Radius: If non-zero, when this entity breaks it will create an explosion with a radius of the specified amount. See also 'Explosion Damage'."
dropdownlist wwmt_performancemode_ui "Performance Mode" type:#string items:#("Normal","No Gibs","Full Gibs on All Platforms","Reduced gibs") toolTip:"Performance Mode: Used to limit the amount of gibs produced when this entity breaks, for performance reasons. ="
on wwmt_performancemode_ui selected i do performancemode = propMapperformancemode[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_damagefilter_ui_label "Damage Filter"  toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
editText wwmt_damagefilter_ui "" type:#string toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
pickbutton wwmt_damagefilter_pickme_ui "Pick Damage Filter" message:"Pick Target Entity for Damage Filter" filter:target_name_filter 
on wwmt_damagefilter_pickme_ui picked obj do (
damagefilter = obj.targetname
) 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_4096_ui.checked == true then (
sfs+=4096
)
if params.flag_8192_ui.checked == true then (
sfs+=8192
)
if params.flag_16384_ui.checked == true then (
sfs+=16384
)
if params.flag_32768_ui.checked == true then (
sfs+=32768
)
if params.flag_65536_ui.checked == true then (
sfs+=65536
)
if params.flag_131072_ui.checked == true then (
sfs+=131072
)
if params.flag_262144_ui.checked == true then (
sfs+=262144
)
if params.flag_524288_ui.checked == true then (
sfs+=524288
)
if params.flag_1048576_ui.checked == true then (
sfs+=1048576
)
if params.flag_2097152_ui.checked == true then (
sfs+=2097152
)
if params.flag_4194304_ui.checked == true then (
sfs+=4194304
)
if params.flag_8388608_ui.checked == true then (
sfs+=8388608
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_4096_ui "Start Asleep" type:#integer

on flag_4096_ui changed theState do (
addFlags()
)
checkbox flag_8192_ui "Ignore +USE for Pickup" type:#integer

on flag_8192_ui changed theState do (
addFlags()
)
checkbox flag_16384_ui "Debris - Don't collide with the player or other debris" type:#integer

on flag_16384_ui changed theState do (
addFlags()
)
checkbox flag_32768_ui "Motion Disabled" type:#integer

on flag_32768_ui changed theState do (
addFlags()
)
checkbox flag_65536_ui "Use Preferred Carry Angles" type:#integer

on flag_65536_ui changed theState do (
addFlags()
)
checkbox flag_131072_ui "Enable motion on Physcannon grab" type:#integer

on flag_131072_ui changed theState do (
addFlags()
)
checkbox flag_262144_ui "Not affected by rotor wash" type:#integer

on flag_262144_ui changed theState do (
addFlags()
)
checkbox flag_524288_ui "Generate output on +USE" type:#integer

on flag_524288_ui changed theState do (
addFlags()
)
checkbox flag_1048576_ui "Physgun can ALWAYS pick up. No matter what." type:#integer

on flag_1048576_ui changed theState do (
addFlags()
)
checkbox flag_2097152_ui "Physgun is NOT allowed to pick this up." type:#integer

on flag_2097152_ui changed theState do (
addFlags()
)
checkbox flag_4194304_ui "Physgun is NOT allowed to punt this object." type:#integer

on flag_4194304_ui changed theState do (
addFlags()
)
checkbox flag_8388608_ui "Prevent motion enable on player bump" type:#integer

on flag_8388608_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Only Break on Trigger" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Break on Touch" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Break on Pressure" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Break immediately on Physics" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Don't take physics damage" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Don't allow bullet penetration" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_physbox" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_physbox_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_physbox&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_physbox" address:"https://developer.valvesoftware.com/wiki/func_physbox?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if damagetype != undefined AND findItem propMapdamagetype damagetype == 0 then (
 append propMapdamagetype damagetype
tmp = wwmt_damagetype_ui.items
 append tmp damagetype
wwmt_damagetype_ui.items = tmp
wwmt_damagetype_ui.selection = propMapdamagetype.count
) else ( 
 if damagetype != undefined then (
wwmt_damagetype_ui.selection = (findItem propMapdamagetype damagetype)
)
)
 if notsolid != undefined AND findItem propMapnotsolid notsolid == 0 then (
 append propMapnotsolid notsolid
tmp = wwmt_notsolid_ui.items
 append tmp notsolid
wwmt_notsolid_ui.items = tmp
wwmt_notsolid_ui.selection = propMapnotsolid.count
) else ( 
 if notsolid != undefined then (
wwmt_notsolid_ui.selection = (findItem propMapnotsolid notsolid)
)
)
 if propdata != undefined AND findItem propMappropdata propdata == 0 then (
 append propMappropdata propdata
tmp = wwmt_propdata_ui.items
 append tmp propdata
wwmt_propdata_ui.items = tmp
wwmt_propdata_ui.selection = propMappropdata.count
) else ( 
 if propdata != undefined then (
wwmt_propdata_ui.selection = (findItem propMappropdata propdata)
)
)
 if wwmt_material != undefined AND findItem propMapmaterial wwmt_material == 0 then (
 append propMapmaterial wwmt_material
tmp = wwmt_material_ui.items
 append tmp wwmt_material
wwmt_material_ui.items = tmp
wwmt_material_ui.selection = propMapmaterial.count
) else ( 
 if wwmt_material != undefined then (
wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
)
)
 if explosion != undefined AND findItem propMapexplosion explosion == 0 then (
 append propMapexplosion explosion
tmp = wwmt_explosion_ui.items
 append tmp explosion
wwmt_explosion_ui.items = tmp
wwmt_explosion_ui.selection = propMapexplosion.count
) else ( 
 if explosion != undefined then (
wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
)
)
 if nodamageforces != undefined AND findItem propMapnodamageforces nodamageforces == 0 then (
 append propMapnodamageforces nodamageforces
tmp = wwmt_nodamageforces_ui.items
 append tmp nodamageforces
wwmt_nodamageforces_ui.items = tmp
wwmt_nodamageforces_ui.selection = propMapnodamageforces.count
) else ( 
 if nodamageforces != undefined then (
wwmt_nodamageforces_ui.selection = (findItem propMapnodamageforces nodamageforces)
)
)
 if spawnobject != undefined AND findItem propMapspawnobject spawnobject == 0 then (
 append propMapspawnobject spawnobject
tmp = wwmt_spawnobject_ui.items
 append tmp spawnobject
wwmt_spawnobject_ui.items = tmp
wwmt_spawnobject_ui.selection = propMapspawnobject.count
) else ( 
 if spawnobject != undefined then (
wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
)
)
 if performancemode != undefined AND findItem propMapperformancemode performancemode == 0 then (
 append propMapperformancemode performancemode
tmp = wwmt_performancemode_ui.items
 append tmp performancemode
wwmt_performancemode_ui.items = tmp
wwmt_performancemode_ui.selection = propMapperformancemode.count
) else ( 
 if performancemode != undefined then (
wwmt_performancemode_ui.selection = (findItem propMapperformancemode performancemode)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 4096 == 4096 then (
flag_4096_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8192 == 8192 then (
flag_8192_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16384 == 16384 then (
flag_16384_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32768 == 32768 then (
flag_32768_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 65536 == 65536 then (
flag_65536_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 131072 == 131072 then (
flag_131072_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 262144 == 262144 then (
flag_262144_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 524288 == 524288 then (
flag_524288_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1048576 == 1048576 then (
flag_1048576_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2097152 == 2097152 then (
flag_2097152_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4194304 == 4194304 then (
flag_4194304_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8388608 == 8388608 then (
flag_8388608_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_areaportal_CA = attributes "WW Entity func_areaportal" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_areaportal"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Close","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Open","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 255.0 255.0)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartopen="1"
local propMapstartopen=#("0","1")
local exportProps=#("wwmt_target","startopen","portalversion","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
startopen type:#string ui:wwmt_startopen_ui default:"1"
portalversion type:#string ui:wwmt_portalversion_ui default:"1"
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_areaportal"
label wwmt_target_ui_label "Name of Linked Door"  toolTip:"Name of Linked Door: (Optional) The name of a door whose open/closed state controls the on/off state of this area portal."
editText wwmt_target_ui "" type:#string toolTip:"Name of Linked Door: (Optional) The name of a door whose open/closed state controls the on/off state of this area portal."
pickbutton wwmt_target_pickme_ui "Pick Name of Linked Door" message:"Pick Target Entity for Name of Linked Door" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
dropdownlist wwmt_startopen_ui "Initial State" type:#string items:#("Closed","Open")
on wwmt_startopen_ui selected i do startopen = propMapstartopen[i] 
label wwmt_portalversion_ui_label "Portal Version"  toolTip:"Portal Version: (Don't change). Differentiates between shipping HL2 maps and maps using new engine features."
editText wwmt_portalversion_ui "" type:#string toolTip:"Portal Version: (Don't change). Differentiates between shipping HL2 maps and maps using new engine features."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_areaportal" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_areaportal_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_areaportal&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_areaportal" address:"https://developer.valvesoftware.com/wiki/func_areaportal?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startopen != undefined AND findItem propMapstartopen startopen == 0 then (
 append propMapstartopen startopen
tmp = wwmt_startopen_ui.items
 append tmp startopen
wwmt_startopen_ui.items = tmp
wwmt_startopen_ui.selection = propMapstartopen.count
) else ( 
 if startopen != undefined then (
wwmt_startopen_ui.selection = (findItem propMapstartopen startopen)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_occluder_CA = attributes "WW Entity func_occluder" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_occluder"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("Activate","AddOutput","Deactivate","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 255.0 255.0)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartactive="1"
local propMapstartactive=#("0","1")
local exportProps=#("startactive","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
startactive type:#string ui:wwmt_startactive_ui default:"1"
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_occluder"
dropdownlist wwmt_startactive_ui "Initial State" type:#string items:#("Inactive","Active")
on wwmt_startactive_ui selected i do startactive = propMapstartactive[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_occluder" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_occluder_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_occluder&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_occluder" address:"https://developer.valvesoftware.com/wiki/func_occluder?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startactive != undefined AND findItem propMapstartactive startactive == 0 then (
 append propMapstartactive startactive
tmp = wwmt_startactive_ui.items
 append tmp startactive
wwmt_startactive_ui.items = tmp
wwmt_startactive_ui.selection = propMapstartactive.count
) else ( 
 if startactive != undefined then (
wwmt_startactive_ui.selection = (findItem propMapstartactive startactive)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_breakable_CA = attributes "WW Entity func_breakable" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_breakable"
local hasOutputs = true
local availableOutputs=#("OnBreak","OnHealthChanged","OnPhysCannonAnimatePostStarted","OnPhysCannonAnimatePreStarted","OnPhysCannonAnimatePullStarted","OnPhysCannonDetach","OnPhysCannonPullAnimFinished","OnTakeDamage","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddHealth","AddOutput","Alpha","Break","ClearParent","Color","DisableDamageForces","DisablePhyscannonPickup","DisableShadow","EnableDamageForces","EnablePhyscannonPickup","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","RemoveHealth","SetDamageFilter","SetHealth","SetMass","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValpropdata="0"
local propMappropdata=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24")
local propValmaterial="0"
local propMapmaterial=#("0","1","2","3","4","5","6","7","8","// 9","10")
local propValexplosion="0"
local propMapexplosion=#("0","1","2")
local propValnodamageforces="0"
local propMapnodamageforces=#("0","1")
local propValspawnobject="0"
local propMapspawnobject=#("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26")
local propValperformancemode="0"
local propMapperformancemode=#("0","1","2","3")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("minhealthdmg","_minlight","physdamagescale","propdata","health","wwmt_material","explosion","gibdir","nodamageforces","gibmodel","spawnobject","explodemagnitude","pressuredelay","explodedamage","exploderadius","performancemode","targetname","damagefilter","disableshadows","parentname","globalname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
minhealthdmg type:#integer ui:wwmt_minhealthdmg_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
physdamagescale type:#float ui:wwmt_physdamagescale_ui default:1.0
propdata type:#string ui:wwmt_propdata_ui default:"0"
health type:#integer ui:wwmt_health_ui default:1
wwmt_material type:#string ui:wwmt_material_ui default:"0"
explosion type:#string ui:wwmt_explosion_ui default:"0"
gibdir type:#string ui:wwmt_gibdir_ui default:"0 0 0"
nodamageforces type:#string ui:wwmt_nodamageforces_ui default:"0"
gibmodel type:#string ui:wwmt_gibmodel_ui default:""
spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
pressuredelay type:#float ui:wwmt_pressuredelay_ui default:0
explodedamage type:#float ui:wwmt_explodedamage_ui default:0
exploderadius type:#float ui:wwmt_exploderadius_ui default:0
performancemode type:#string ui:wwmt_performancemode_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
damagefilter type:#string ui:wwmt_damagefilter_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
parentname type:#string ui:wwmt_parentname_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_breakable"
spinner wwmt_minhealthdmg_ui "Min Damage to" type:#integer range:[-10000,10000,0] toolTip:"Min Damage to Hurt: The prop will ignore any damage events if the damage is less than this amount."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
spinner wwmt_physdamagescale_ui "Physics Impac" type:#float scale:0.001 range:[-10000.000,10000.000,1] toolTip:"Physics Impact Damage Scale: 0 means this feature is disabled for backwards compatibility.\nSet to 1.0 for materials as strong as flesh, smaller numbers indicate stronger materials."
dropdownlist wwmt_propdata_ui "Prop Data" type:#string items:#("None","Wooden.Tiny","Wooden.Small","Wooden.Medium","Wooden.Large","Wooden.Huge","Metal.Small","Metal.Medium","Metal.Large","Cardboard.Small","Cardboard.Medium","Cardboard.Large","Stone.Small","Stone.Medium","Stone.Large","Stone.Huge","Glass.Small","Plastic.Small","Plastic.Medium","Plastic.Large","Pottery.Small","Pottery.Medium","Pottery.Large","Pottery.Huge","Glass.Window") toolTip:"Prop Data: Set to the best approximation of the size and material of this entity's brushes. If set, it will override this entity's health and damage taken from various weapons. See the propdata.txt file in the scripts directory of your MOD to get a detailed list of what each entry specifies. ="
on wwmt_propdata_ui selected i do propdata = propMappropdata[i] 
spinner wwmt_health_ui "Strength" type:#integer range:[-10000,10000,1] toolTip:"Strength: Number of points of damage to take before breaking. 0 means don't break."
dropdownlist wwmt_material_ui "Material Type" type:#string items:#("Glass","Wood","Metal","Flesh","CinderBlock","Ceiling Tile","Computer","Unbreakable Glass","Rocks","Web(defunct)","None") toolTip:"Material Type: Set to the material type of the brush. Used to decide what sounds to make when damaged, and what gibs to produce when broken. ="
on wwmt_material_ui selected i do wwmt_material = propMapmaterial[i] 
dropdownlist wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random","Relative to Attack","Use Precise Gib Dir") toolTip:"Gibs Direction: Used to decide which direction to throw gibs when broken. ="
on wwmt_explosion_ui selected i do explosion = propMapexplosion[i] 
label wwmt_gibdir_ui_label "Precise Gib Direction"  toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
editText wwmt_gibdir_ui "" type:#string toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
dropdownlist wwmt_nodamageforces_ui "Damaging it Doesn't Push It" type:#string items:#("No","Yes") toolTip:"Damaging it Doesn't Push It: Used to determine whether or not damage should cause the brush to move. ="
on wwmt_nodamageforces_ui selected i do nodamageforces = propMapnodamageforces[i] 
label wwmt_gibmodel_ui_label "Gib Model"  toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
editText wwmt_gibmodel_ui "" type:#string toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
dropdownlist wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("item_battery","item_healthkit","item_ammo_pistol","item_ammo_pistol_large","item_ammo_smg1","item_ammo_smg1_large","item_ammo_ar2","item_ammo_ar2_large","item_box_buckshot","item_flare_round","item_box_flare_rounds","item_ml_grenade","item_smg1_grenade","item_box_sniper_rounds","unused1","weapon_stunstick","weapon_ar1","weapon_ar2","unused2","weapon_ml","weapon_smg1","weapon_smg2","weapon_slam","weapon_shotgun","weapon_molotov","item_dynamic_resupply") toolTip:"Spawn On Break: When broken, an entity of the selected type will be created. ="
on wwmt_spawnobject_ui selected i do spawnobject = propMapspawnobject[i] 
spinner wwmt_explodemagnitude_ui "Explode Magni" type:#integer range:[-10000,10000,0] toolTip:"Explode Magnitude: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage."
spinner wwmt_pressuredelay_ui "Pressure Dela" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Pressure Delay: Delay, in seconds, after 'broken' by pressure before breaking apart (allows for sound to play before breaking apart)."
spinner wwmt_explodedamage_ui "Explosion Dam" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Damage: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage. See also 'Explosion Radius'."
spinner wwmt_exploderadius_ui "Explosion Rad" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Radius: If non-zero, when this entity breaks it will create an explosion with a radius of the specified amount. See also 'Explosion Damage'."
dropdownlist wwmt_performancemode_ui "Performance Mode" type:#string items:#("Normal","No Gibs","Full Gibs on All Platforms","Reduced gibs") toolTip:"Performance Mode: Used to limit the amount of gibs produced when this entity breaks, for performance reasons. ="
on wwmt_performancemode_ui selected i do performancemode = propMapperformancemode[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_damagefilter_ui_label "Damage Filter"  toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
editText wwmt_damagefilter_ui "" type:#string toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
pickbutton wwmt_damagefilter_pickme_ui "Pick Damage Filter" message:"Pick Target Entity for Damage Filter" filter:target_name_filter 
on wwmt_damagefilter_pickme_ui picked obj do (
damagefilter = obj.targetname
) 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Only Break on Trigger" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Break on Touch" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Break on Pressure" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Break immediately on Physics" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Don't take physics damage" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Don't allow bullet penetration" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_breakable" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_breakable_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_breakable&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_breakable" address:"https://developer.valvesoftware.com/wiki/func_breakable?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if propdata != undefined AND findItem propMappropdata propdata == 0 then (
 append propMappropdata propdata
tmp = wwmt_propdata_ui.items
 append tmp propdata
wwmt_propdata_ui.items = tmp
wwmt_propdata_ui.selection = propMappropdata.count
) else ( 
 if propdata != undefined then (
wwmt_propdata_ui.selection = (findItem propMappropdata propdata)
)
)
 if wwmt_material != undefined AND findItem propMapmaterial wwmt_material == 0 then (
 append propMapmaterial wwmt_material
tmp = wwmt_material_ui.items
 append tmp wwmt_material
wwmt_material_ui.items = tmp
wwmt_material_ui.selection = propMapmaterial.count
) else ( 
 if wwmt_material != undefined then (
wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
)
)
 if explosion != undefined AND findItem propMapexplosion explosion == 0 then (
 append propMapexplosion explosion
tmp = wwmt_explosion_ui.items
 append tmp explosion
wwmt_explosion_ui.items = tmp
wwmt_explosion_ui.selection = propMapexplosion.count
) else ( 
 if explosion != undefined then (
wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
)
)
 if nodamageforces != undefined AND findItem propMapnodamageforces nodamageforces == 0 then (
 append propMapnodamageforces nodamageforces
tmp = wwmt_nodamageforces_ui.items
 append tmp nodamageforces
wwmt_nodamageforces_ui.items = tmp
wwmt_nodamageforces_ui.selection = propMapnodamageforces.count
) else ( 
 if nodamageforces != undefined then (
wwmt_nodamageforces_ui.selection = (findItem propMapnodamageforces nodamageforces)
)
)
 if spawnobject != undefined AND findItem propMapspawnobject spawnobject == 0 then (
 append propMapspawnobject spawnobject
tmp = wwmt_spawnobject_ui.items
 append tmp spawnobject
wwmt_spawnobject_ui.items = tmp
wwmt_spawnobject_ui.selection = propMapspawnobject.count
) else ( 
 if spawnobject != undefined then (
wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
)
)
 if performancemode != undefined AND findItem propMapperformancemode performancemode == 0 then (
 append propMapperformancemode performancemode
tmp = wwmt_performancemode_ui.items
 append tmp performancemode
wwmt_performancemode_ui.items = tmp
wwmt_performancemode_ui.selection = propMapperformancemode.count
) else ( 
 if performancemode != undefined then (
wwmt_performancemode_ui.selection = (findItem propMapperformancemode performancemode)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_breakable_surf_CA = attributes "WW Entity func_breakable_surf" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_breakable_surf"
local hasOutputs = true
local availableOutputs=#("OnBreak","OnHealthChanged","OnPhysCannonAnimatePostStarted","OnPhysCannonAnimatePreStarted","OnPhysCannonAnimatePullStarted","OnPhysCannonDetach","OnPhysCannonPullAnimFinished","OnTakeDamage","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddHealth","AddOutput","Alpha","Break","ClearParent","Color","DisableDamageForces","DisablePhyscannonPickup","DisableShadow","EnableDamageForces","EnablePhyscannonPickup","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","RemoveHealth","SetDamageFilter","SetHealth","SetMass","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Shatter")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsurfacetype="0"
local propMapsurfacetype=#("0","1")
local propValpropdata="0"
local propMappropdata=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24")
local propValmaterial="0"
local propMapmaterial=#("0","1","2","3","4","5","6","7","8","// 9","10")
local propValexplosion="0"
local propMapexplosion=#("0","1","2")
local propValnodamageforces="0"
local propMapnodamageforces=#("0","1")
local propValspawnobject="0"
local propMapspawnobject=#("1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26")
local propValperformancemode="0"
local propMapperformancemode=#("0","1","2","3")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("health","fragility","surfacetype","propdata","wwmt_material","explosion","gibdir","nodamageforces","gibmodel","spawnobject","explodemagnitude","pressuredelay","explodedamage","exploderadius","performancemode","targetname","damagefilter","disableshadows","parentname","globalname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
health type:#integer ui:wwmt_health_ui default:5
fragility type:#integer ui:wwmt_fragility_ui default:100
surfacetype type:#string ui:wwmt_surfacetype_ui default:"0"
propdata type:#string ui:wwmt_propdata_ui default:"0"
wwmt_material type:#string ui:wwmt_material_ui default:"0"
explosion type:#string ui:wwmt_explosion_ui default:"0"
gibdir type:#string ui:wwmt_gibdir_ui default:"0 0 0"
nodamageforces type:#string ui:wwmt_nodamageforces_ui default:"0"
gibmodel type:#string ui:wwmt_gibmodel_ui default:""
spawnobject type:#string ui:wwmt_spawnobject_ui default:"0"
explodemagnitude type:#integer ui:wwmt_explodemagnitude_ui default:0
pressuredelay type:#float ui:wwmt_pressuredelay_ui default:0
explodedamage type:#float ui:wwmt_explodedamage_ui default:0
exploderadius type:#float ui:wwmt_exploderadius_ui default:0
performancemode type:#string ui:wwmt_performancemode_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
damagefilter type:#string ui:wwmt_damagefilter_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
parentname type:#string ui:wwmt_parentname_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_breakable_surf"
spinner wwmt_health_ui "Health" type:#integer range:[-10000,10000,5] toolTip:"Health: The amount of damage the surface takes before breaking."
spinner wwmt_fragility_ui "Fragility" type:#integer range:[-10000,10000,100] toolTip:"Fragility: If the 'Surface Type' is set to Glass, this value sets how fragile the glass pieces are after the surface has been broken."
dropdownlist wwmt_surfacetype_ui "Surface Type" type:#string items:#("Glass","Tile")
on wwmt_surfacetype_ui selected i do surfacetype = propMapsurfacetype[i] 
dropdownlist wwmt_propdata_ui "Prop Data" type:#string items:#("None","Wooden.Tiny","Wooden.Small","Wooden.Medium","Wooden.Large","Wooden.Huge","Metal.Small","Metal.Medium","Metal.Large","Cardboard.Small","Cardboard.Medium","Cardboard.Large","Stone.Small","Stone.Medium","Stone.Large","Stone.Huge","Glass.Small","Plastic.Small","Plastic.Medium","Plastic.Large","Pottery.Small","Pottery.Medium","Pottery.Large","Pottery.Huge","Glass.Window") toolTip:"Prop Data: Set to the best approximation of the size and material of this entity's brushes. If set, it will override this entity's health and damage taken from various weapons. See the propdata.txt file in the scripts directory of your MOD to get a detailed list of what each entry specifies. ="
on wwmt_propdata_ui selected i do propdata = propMappropdata[i] 
dropdownlist wwmt_material_ui "Material Type" type:#string items:#("Glass","Wood","Metal","Flesh","CinderBlock","Ceiling Tile","Computer","Unbreakable Glass","Rocks","Web(defunct)","None") toolTip:"Material Type: Set to the material type of the brush. Used to decide what sounds to make when damaged, and what gibs to produce when broken. ="
on wwmt_material_ui selected i do wwmt_material = propMapmaterial[i] 
dropdownlist wwmt_explosion_ui "Gibs Direction" type:#string items:#("Random","Relative to Attack","Use Precise Gib Dir") toolTip:"Gibs Direction: Used to decide which direction to throw gibs when broken. ="
on wwmt_explosion_ui selected i do explosion = propMapexplosion[i] 
label wwmt_gibdir_ui_label "Precise Gib Direction"  toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
editText wwmt_gibdir_ui "" type:#string toolTip:"Precise Gib Direction: Specifies the direction to throw gibs when this breakable breaks. Be sure to select Use Precise Gib Dir in the Gibs Direction field!"
dropdownlist wwmt_nodamageforces_ui "Damaging it Doesn't Push It" type:#string items:#("No","Yes") toolTip:"Damaging it Doesn't Push It: Used to determine whether or not damage should cause the brush to move. ="
on wwmt_nodamageforces_ui selected i do nodamageforces = propMapnodamageforces[i] 
label wwmt_gibmodel_ui_label "Gib Model"  toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
editText wwmt_gibmodel_ui "" type:#string toolTip:"Gib Model: Used by HL1Port to specify a custom gib model to break into, overriding the 'Material Type'."
dropdownlist wwmt_spawnobject_ui "Spawn On Break" type:#string items:#("item_battery","item_healthkit","item_ammo_pistol","item_ammo_pistol_large","item_ammo_smg1","item_ammo_smg1_large","item_ammo_ar2","item_ammo_ar2_large","item_box_buckshot","item_flare_round","item_box_flare_rounds","item_ml_grenade","item_smg1_grenade","item_box_sniper_rounds","unused1","weapon_stunstick","weapon_ar1","weapon_ar2","unused2","weapon_ml","weapon_smg1","weapon_smg2","weapon_slam","weapon_shotgun","weapon_molotov","item_dynamic_resupply") toolTip:"Spawn On Break: When broken, an entity of the selected type will be created. ="
on wwmt_spawnobject_ui selected i do spawnobject = propMapspawnobject[i] 
spinner wwmt_explodemagnitude_ui "Explode Magni" type:#integer range:[-10000,10000,0] toolTip:"Explode Magnitude: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage."
spinner wwmt_pressuredelay_ui "Pressure Dela" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Pressure Delay: Delay, in seconds, after 'broken' by pressure before breaking apart (allows for sound to play before breaking apart)."
spinner wwmt_explodedamage_ui "Explosion Dam" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Damage: If non-zero, when this entity breaks it will create an explosion that causes the specified amount of damage. See also 'Explosion Radius'."
spinner wwmt_exploderadius_ui "Explosion Rad" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Explosion Radius: If non-zero, when this entity breaks it will create an explosion with a radius of the specified amount. See also 'Explosion Damage'."
dropdownlist wwmt_performancemode_ui "Performance Mode" type:#string items:#("Normal","No Gibs","Full Gibs on All Platforms","Reduced gibs") toolTip:"Performance Mode: Used to limit the amount of gibs produced when this entity breaks, for performance reasons. ="
on wwmt_performancemode_ui selected i do performancemode = propMapperformancemode[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_damagefilter_ui_label "Damage Filter"  toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
editText wwmt_damagefilter_ui "" type:#string toolTip:"Damage Filter: Name of the filter entity that controls which entities can damage us."
pickbutton wwmt_damagefilter_pickme_ui "Pick Damage Filter" message:"Pick Target Entity for Damage Filter" filter:target_name_filter 
on wwmt_damagefilter_pickme_ui picked obj do (
damagefilter = obj.targetname
) 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Physics damage decals" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Take damage from held objects" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Break on Pressure" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Break immediately on Physics" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Don't take physics damage" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Don't allow bullet penetration" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_breakable_surf" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_breakable_surf_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_breakable_surf&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_breakable_surf" address:"https://developer.valvesoftware.com/wiki/func_breakable_surf?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if surfacetype != undefined AND findItem propMapsurfacetype surfacetype == 0 then (
 append propMapsurfacetype surfacetype
tmp = wwmt_surfacetype_ui.items
 append tmp surfacetype
wwmt_surfacetype_ui.items = tmp
wwmt_surfacetype_ui.selection = propMapsurfacetype.count
) else ( 
 if surfacetype != undefined then (
wwmt_surfacetype_ui.selection = (findItem propMapsurfacetype surfacetype)
)
)
 if propdata != undefined AND findItem propMappropdata propdata == 0 then (
 append propMappropdata propdata
tmp = wwmt_propdata_ui.items
 append tmp propdata
wwmt_propdata_ui.items = tmp
wwmt_propdata_ui.selection = propMappropdata.count
) else ( 
 if propdata != undefined then (
wwmt_propdata_ui.selection = (findItem propMappropdata propdata)
)
)
 if wwmt_material != undefined AND findItem propMapmaterial wwmt_material == 0 then (
 append propMapmaterial wwmt_material
tmp = wwmt_material_ui.items
 append tmp wwmt_material
wwmt_material_ui.items = tmp
wwmt_material_ui.selection = propMapmaterial.count
) else ( 
 if wwmt_material != undefined then (
wwmt_material_ui.selection = (findItem propMapmaterial wwmt_material)
)
)
 if explosion != undefined AND findItem propMapexplosion explosion == 0 then (
 append propMapexplosion explosion
tmp = wwmt_explosion_ui.items
 append tmp explosion
wwmt_explosion_ui.items = tmp
wwmt_explosion_ui.selection = propMapexplosion.count
) else ( 
 if explosion != undefined then (
wwmt_explosion_ui.selection = (findItem propMapexplosion explosion)
)
)
 if nodamageforces != undefined AND findItem propMapnodamageforces nodamageforces == 0 then (
 append propMapnodamageforces nodamageforces
tmp = wwmt_nodamageforces_ui.items
 append tmp nodamageforces
wwmt_nodamageforces_ui.items = tmp
wwmt_nodamageforces_ui.selection = propMapnodamageforces.count
) else ( 
 if nodamageforces != undefined then (
wwmt_nodamageforces_ui.selection = (findItem propMapnodamageforces nodamageforces)
)
)
 if spawnobject != undefined AND findItem propMapspawnobject spawnobject == 0 then (
 append propMapspawnobject spawnobject
tmp = wwmt_spawnobject_ui.items
 append tmp spawnobject
wwmt_spawnobject_ui.items = tmp
wwmt_spawnobject_ui.selection = propMapspawnobject.count
) else ( 
 if spawnobject != undefined then (
wwmt_spawnobject_ui.selection = (findItem propMapspawnobject spawnobject)
)
)
 if performancemode != undefined AND findItem propMapperformancemode performancemode == 0 then (
 append propMapperformancemode performancemode
tmp = wwmt_performancemode_ui.items
 append tmp performancemode
wwmt_performancemode_ui.items = tmp
wwmt_performancemode_ui.selection = propMapperformancemode.count
) else ( 
 if performancemode != undefined then (
wwmt_performancemode_ui.selection = (findItem propMapperformancemode performancemode)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_conveyor_CA = attributes "WW Entity func_conveyor" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_conveyor"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","ToggleDirection")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("movedir","speed","_minlight","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
movedir type:#string ui:wwmt_movedir_ui default:"0 0 0"
speed type:#string ui:wwmt_speed_ui default:"100"
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_conveyor"
label wwmt_movedir_ui_label "Move Direction (Pitch Yaw Roll)"  toolTip:"Move Direction (Pitch Yaw Roll): The direction conveyor moves."
editText wwmt_movedir_ui "" type:#string toolTip:"Move Direction (Pitch Yaw Roll): The direction conveyor moves."
label wwmt_speed_ui_label "Conveyor Speed" 
editText wwmt_speed_ui "" type:#string
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Push" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Not Solid" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_conveyor" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_conveyor_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_conveyor&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_conveyor" address:"https://developer.valvesoftware.com/wiki/func_conveyor?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_detail_CA = attributes "WW Entity func_detail" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_detail"
local hasOutputs = false
local hasInputs = false

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 0.0 180.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValmindxlevel="0"
local propMapmindxlevel=#("0","70","80","81","90","95")
local propValmaxdxlevel="0"
local propMapmaxdxlevel=#("0","60","70","80","81","90","95")
local exportProps=#("mindxlevel","maxdxlevel")

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
mindxlevel type:#string ui:wwmt_mindxlevel_ui default:"0"
maxdxlevel type:#string ui:wwmt_maxdxlevel_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_detail"
dropdownlist wwmt_mindxlevel_ui "Minimum DX Level" type:#string items:#("default (lowest)","dx7","dx8.0 (4600Ti)","dx8.1 (FX5200)","dx9 SM2.0","dx9 SM3.0")
on wwmt_mindxlevel_ui selected i do mindxlevel = propMapmindxlevel[i] 
dropdownlist wwmt_maxdxlevel_ui "Maximum DX Level" type:#string items:#("default (highest)","dx6","dx7","dx8.0 (4600Ti)","dx8.1 (FX5200)","dx9 SM2.0","dx9 SM3.0")
on wwmt_maxdxlevel_ui selected i do maxdxlevel = propMapmaxdxlevel[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_detail" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_detail_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_detail&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_detail" address:"https://developer.valvesoftware.com/wiki/func_detail?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if mindxlevel != undefined AND findItem propMapmindxlevel mindxlevel == 0 then (
 append propMapmindxlevel mindxlevel
tmp = wwmt_mindxlevel_ui.items
 append tmp mindxlevel
wwmt_mindxlevel_ui.items = tmp
wwmt_mindxlevel_ui.selection = propMapmindxlevel.count
) else ( 
 if mindxlevel != undefined then (
wwmt_mindxlevel_ui.selection = (findItem propMapmindxlevel mindxlevel)
)
)
 if maxdxlevel != undefined AND findItem propMapmaxdxlevel maxdxlevel == 0 then (
 append propMapmaxdxlevel maxdxlevel
tmp = wwmt_maxdxlevel_ui.items
 append tmp maxdxlevel
wwmt_maxdxlevel_ui.items = tmp
wwmt_maxdxlevel_ui.selection = propMapmaxdxlevel.count
) else ( 
 if maxdxlevel != undefined then (
wwmt_maxdxlevel_ui.selection = (findItem propMapmaxdxlevel maxdxlevel)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_viscluster_CA = attributes "WW Entity func_viscluster" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_viscluster"
local hasOutputs = false
local hasInputs = false

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)
local entcolor=(color 180.0 180.0 0.0)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#()

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true

)
rollout params "Entity Properties"
(
label entityLabel "func_viscluster"

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_viscluster" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_viscluster_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_viscluster&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_viscluster" address:"https://developer.valvesoftware.com/wiki/func_viscluster?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_illusionary_CA = attributes "WW Entity func_illusionary" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_illusionary"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("_minlight","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"

)
rollout params "Entity Properties"
(
label entityLabel "func_illusionary"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_illusionary" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_illusionary_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_illusionary&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_illusionary" address:"https://developer.valvesoftware.com/wiki/func_illusionary?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_precipitation_CA = attributes "WW Entity func_precipitation" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_precipitation"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValpreciptype="0"
local propMappreciptype=#("0","1","2","3")
local exportProps=#("renderamt","rendercolor","preciptype","targetname","parentname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
renderamt type:#integer ui:wwmt_renderamt_ui default:5
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 100 100 100 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
preciptype type:#string ui:wwmt_preciptype_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_precipitation"
spinner wwmt_renderamt_ui "Density (0-10" type:#integer range:[-10000,10000,5]
colorPicker wwmt_rendercolor_ui "Color (R G B)" color:( color 100 100 100 )
spinner wwmt_rendercolor_inensity_ui "Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for Color (R G B)"
dropdownlist wwmt_preciptype_ui "Precipitation Type" type:#string items:#("Rain","Snow","Ash","Snowfall")
on wwmt_preciptype_ui selected i do preciptype = propMappreciptype[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_precipitation" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_precipitation_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_precipitation&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_precipitation" address:"https://developer.valvesoftware.com/wiki/func_precipitation?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if preciptype != undefined AND findItem propMappreciptype preciptype == 0 then (
 append propMappreciptype preciptype
tmp = wwmt_preciptype_ui.items
 append tmp preciptype
wwmt_preciptype_ui.items = tmp
wwmt_preciptype_ui.selection = propMappreciptype.count
) else ( 
 if preciptype != undefined then (
wwmt_preciptype_ui.selection = (findItem propMappreciptype preciptype)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_wall_toggle_CA = attributes "WW Entity func_wall_toggle" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_wall_toggle"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("_minlight","targetname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_wall_toggle"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Starts Invisible" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_wall_toggle" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_wall_toggle_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_wall_toggle&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_wall_toggle" address:"https://developer.valvesoftware.com/wiki/func_wall_toggle?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_guntarget_CA = attributes "WW Entity func_guntarget" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_guntarget"
local hasOutputs = true
local availableOutputs=#("OnDeath","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Start","Stop","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local exportProps=#("speed","wwmt_target","health","_minlight","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:100
wwmt_target type:#string ui:wwmt_target_ui default:""
health type:#integer ui:wwmt_health_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_guntarget"
spinner wwmt_speed_ui "Speed (units " type:#integer range:[-10000,10000,100] toolTip:"Speed (units per second): The speed at which the target moves along its path."
label wwmt_target_ui_label "First stop target"  toolTip:"First stop target: The name of the first path_track entity in the path that this target should follow."
editText wwmt_target_ui "" type:#string toolTip:"First stop target: The name of the first path_track entity in the path that this target should follow."
pickbutton wwmt_target_pickme_ui "Pick First stop target" message:"Pick Target Entity for First stop target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_health_ui "Damage to Tak" type:#integer range:[-10000,10000,0] toolTip:"Damage to Take: The amount of damage taken before this target is killed."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_guntarget" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_guntarget_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_guntarget&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_guntarget" address:"https://developer.valvesoftware.com/wiki/func_guntarget?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_trackautochange_CA = attributes "WW Entity func_trackautochange" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_trackautochange"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Trigger")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local exportProps=#("_minlight","height","rotation","train","toptrack","bottomtrack","speed","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","movesnd","stopsnd","volume")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
height type:#integer ui:wwmt_height_ui default:0
rotation type:#integer ui:wwmt_rotation_ui default:0
train type:#string ui:wwmt_train_ui default:""
toptrack type:#string ui:wwmt_toptrack_ui default:""
bottomtrack type:#string ui:wwmt_bottomtrack_ui default:""
speed type:#integer ui:wwmt_speed_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
volume type:#string ui:wwmt_volume_ui default:"0.85"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_trackautochange"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
spinner wwmt_height_ui "Travel Altitu" type:#integer range:[-10000,10000,0] toolTip:"Travel Altitude: The vertical height above the track that the train moves. Negative values moves the train below."
spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000,10000,0] toolTip:"Spin amount: The amount this platform should rotate as it moves, in degrees."
label wwmt_train_ui_label "Train to Switch // NEEDHELP" 
editText wwmt_train_ui "" type:#string
pickbutton wwmt_train_pickme_ui "Pick Train to Switch // NEEDHELP" message:"Pick Target Entity for Train to Switch // NEEDHELP" filter:target_name_filter 
on wwmt_train_pickme_ui picked obj do (
train = obj.targetname
) 
label wwmt_toptrack_ui_label "Top Track // NEEDHELP" 
editText wwmt_toptrack_ui "" type:#string
pickbutton wwmt_toptrack_pickme_ui "Pick Top Track // NEEDHELP" message:"Pick Target Entity for Top Track // NEEDHELP" filter:target_name_filter 
on wwmt_toptrack_pickme_ui picked obj do (
toptrack = obj.targetname
) 
label wwmt_bottomtrack_ui_label "Bottom Track // NEEDHELP" 
editText wwmt_bottomtrack_ui "" type:#string
pickbutton wwmt_bottomtrack_pickme_ui "Pick Bottom Track // NEEDHELP" message:"Pick Target Entity for Bottom Track // NEEDHELP" filter:target_name_filter 
on wwmt_bottomtrack_pickme_ui picked obj do (
bottomtrack = obj.targetname
) 
spinner wwmt_speed_ui "Move/Rotate S" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeek elev","odd elev 1","odd elev 2") toolTip:"Move Sound: The sound played whenever the platform starts moving. ="
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeek stop","quick stop") toolTip:"Stop Sound: The sound played when the platform stops moving. ="
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" 
editText wwmt_volume_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Auto Activate train" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Relink track" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Start at Bottom" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Rotate Only" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_trackautochange" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_trackautochange_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackautochange&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_trackautochange" address:"https://developer.valvesoftware.com/wiki/func_trackautochange?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_trackchange_CA = attributes "WW Entity func_trackchange" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_trackchange"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValmovesnd="0"
local propMapmovesnd=#("0","1","2","3","4","5","6","7","8","9","10","11","12","13")
local propValstopsnd="0"
local propMapstopsnd=#("0","1","2","3","4","5","6","7","8")
local exportProps=#("_minlight","height","rotation","train","toptrack","bottomtrack","speed","targetname","parentname","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","movesnd","stopsnd","volume")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
height type:#integer ui:wwmt_height_ui default:0
rotation type:#integer ui:wwmt_rotation_ui default:0
train type:#string ui:wwmt_train_ui default:""
toptrack type:#string ui:wwmt_toptrack_ui default:""
bottomtrack type:#string ui:wwmt_bottomtrack_ui default:""
speed type:#integer ui:wwmt_speed_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
movesnd type:#string ui:wwmt_movesnd_ui default:"0"
stopsnd type:#string ui:wwmt_stopsnd_ui default:"0"
volume type:#string ui:wwmt_volume_ui default:"0.85"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_trackchange"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
spinner wwmt_height_ui "Travel Altitu" type:#integer range:[-10000,10000,0] toolTip:"Travel Altitude: The vertical height above the track that the train moves. Negative values moves the train below."
spinner wwmt_rotation_ui "Spin amount" type:#integer range:[-10000,10000,0] toolTip:"Spin amount: The amount this platform should rotate as it moves, in degrees."
label wwmt_train_ui_label "Train to Switch // NEEDHELP" 
editText wwmt_train_ui "" type:#string
pickbutton wwmt_train_pickme_ui "Pick Train to Switch // NEEDHELP" message:"Pick Target Entity for Train to Switch // NEEDHELP" filter:target_name_filter 
on wwmt_train_pickme_ui picked obj do (
train = obj.targetname
) 
label wwmt_toptrack_ui_label "Top Track // NEEDHELP" 
editText wwmt_toptrack_ui "" type:#string
pickbutton wwmt_toptrack_pickme_ui "Pick Top Track // NEEDHELP" message:"Pick Target Entity for Top Track // NEEDHELP" filter:target_name_filter 
on wwmt_toptrack_pickme_ui picked obj do (
toptrack = obj.targetname
) 
label wwmt_bottomtrack_ui_label "Bottom Track // NEEDHELP" 
editText wwmt_bottomtrack_ui "" type:#string
pickbutton wwmt_bottomtrack_pickme_ui "Pick Bottom Track // NEEDHELP" message:"Pick Target Entity for Bottom Track // NEEDHELP" filter:target_name_filter 
on wwmt_bottomtrack_pickme_ui picked obj do (
bottomtrack = obj.targetname
) 
spinner wwmt_speed_ui "Move/Rotate S" type:#integer range:[-10000,10000,0]
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_movesnd_ui "Move Sound" type:#string items:#("No Sound","big elev 1","big elev 2","tech elev 1","tech elev 2","tech elev 3","freight elev 1","freight elev 2","heavy elev","rack elev","rail elev","squeek elev","odd elev 1","odd elev 2") toolTip:"Move Sound: The sound played whenever the platform starts moving. ="
on wwmt_movesnd_ui selected i do movesnd = propMapmovesnd[i] 
dropdownlist wwmt_stopsnd_ui "Stop Sound" type:#string items:#("No Sound","big elev stop1","big elev stop2","freight elev stop","heavy elev stop","rack stop","rail stop","squeek stop","quick stop") toolTip:"Stop Sound: The sound played when the platform stops moving. ="
on wwmt_stopsnd_ui selected i do stopsnd = propMapstopsnd[i] 
label wwmt_volume_ui_label "Sound Volume 0.0 - 1.0" 
editText wwmt_volume_ui "" type:#string

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Auto Activate train" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "Relink track" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Start at Bottom" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Rotate Only" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "X Axis" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Y Axis" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_trackchange" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_trackchange_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_trackchange&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_trackchange" address:"https://developer.valvesoftware.com/wiki/func_trackchange?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if movesnd != undefined AND findItem propMapmovesnd movesnd == 0 then (
 append propMapmovesnd movesnd
tmp = wwmt_movesnd_ui.items
 append tmp movesnd
wwmt_movesnd_ui.items = tmp
wwmt_movesnd_ui.selection = propMapmovesnd.count
) else ( 
 if movesnd != undefined then (
wwmt_movesnd_ui.selection = (findItem propMapmovesnd movesnd)
)
)
 if stopsnd != undefined AND findItem propMapstopsnd stopsnd == 0 then (
 append propMapstopsnd stopsnd
tmp = wwmt_stopsnd_ui.items
 append tmp stopsnd
wwmt_stopsnd_ui.items = tmp
wwmt_stopsnd_ui.selection = propMapstopsnd.count
) else ( 
 if stopsnd != undefined then (
wwmt_stopsnd_ui.selection = (findItem propMapstopsnd stopsnd)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_tracktrain_CA = attributes "WW Entity func_tracktrain" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tracktrain"
local hasOutputs = true
local availableOutputs=#("OnNext","OnStart","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Resume","Reverse","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","SetSpeedDir","SetSpeedReal","StartBackward","StartForward","Stop","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValvelocitytype="0"
local propMapvelocitytype=#("0","1","2")
local propValorientationtype="1"
local propMaporientationtype=#("0","1","2","3")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("wwmt_target","startspeed","speed","velocitytype","orientationtype","wheels","height","bank","dmg","_minlight","movesound","movepingsound","startsound","stopsound","volume","movesoundminpitch","movesoundmaxpitch","movesoundmintime","movesoundmaxtime","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
startspeed type:#integer ui:wwmt_startspeed_ui default:100
speed type:#integer ui:wwmt_speed_ui default:0
velocitytype type:#string ui:wwmt_velocitytype_ui default:"0"
orientationtype type:#string ui:wwmt_orientationtype_ui default:"1"
wheels type:#integer ui:wwmt_wheels_ui default:50
height type:#integer ui:wwmt_height_ui default:4
bank type:#string ui:wwmt_bank_ui default:"0"
dmg type:#integer ui:wwmt_dmg_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
movesound type:#string ui:wwmt_movesound_ui default:""
movepingsound type:#string ui:wwmt_movepingsound_ui default:""
startsound type:#string ui:wwmt_startsound_ui default:""
stopsound type:#string ui:wwmt_stopsound_ui default:""
volume type:#integer ui:wwmt_volume_ui default:10
movesoundminpitch type:#integer ui:wwmt_movesoundminpitch_ui default:60
movesoundmaxpitch type:#integer ui:wwmt_movesoundmaxpitch_ui default:200
movesoundmintime type:#float ui:wwmt_movesoundmintime_ui default:0
movesoundmaxtime type:#float ui:wwmt_movesoundmaxtime_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_tracktrain"
label wwmt_target_ui_label "First Stop Target"  toolTip:"First Stop Target: The name of the first path_track in the train's path. The train +"
editText wwmt_target_ui "" type:#string toolTip:"First Stop Target: The name of the first path_track in the train's path. The train +"
pickbutton wwmt_target_pickme_ui "Pick First Stop Target" message:"Pick Target Entity for First Stop Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_startspeed_ui "Max Speed (un" type:#integer range:[-10000,10000,100] toolTip:"Max Speed (units / second): The maximum speed that this train can move. +"
spinner wwmt_speed_ui "Initial Speed" type:#integer range:[-10000,10000,0] toolTip:"Initial Speed (units / second): The speed that the train will move at after it spawns, 0 = stopped."
dropdownlist wwmt_velocitytype_ui "Change Velocity" type:#string items:#("Instantaneously","Linear blend","Ease in/ease out") toolTip:"Change Velocity: The method through which this train changes its velocity as it moves along the path. ="
on wwmt_velocitytype_ui selected i do velocitytype = propMapvelocitytype[i] 
dropdownlist wwmt_orientationtype_ui "Change angles" type:#string items:#("Never (fixed orientation)","Near path_tracks","Linear blend","Ease in/ease out") toolTip:"Change angles: The method through which this train changes its orientation as it moves along the path. ="
on wwmt_orientationtype_ui selected i do orientationtype = propMaporientationtype[i] 
spinner wwmt_wheels_ui "Distance Betw" type:#integer range:[-10000,10000,50] toolTip:"Distance Between the Wheels: Used for turning and stopping."
spinner wwmt_height_ui "Height above " type:#integer range:[-10000,10000,4] toolTip:"Height above track: The height above the track that this train moves."
label wwmt_bank_ui_label "Bank Angle on Turns" 
editText wwmt_bank_ui "" type:#string
spinner wwmt_dmg_ui "Damage on Cru" type:#integer range:[-10000,10000,0] toolTip:"Damage on Crush: The amount of damage this train does to entities that block it."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_movesound_ui_label "Move Sound"  toolTip:"Move Sound: A sound that is played (and looped) while the train is moving."
editText wwmt_movesound_ui "" type:#string toolTip:"Move Sound: A sound that is played (and looped) while the train is moving."
label wwmt_movepingsound_ui_label "Move Ping Sound"  toolTip:"Move Ping Sound: A sound that is played more frequently as the train speeds up."
editText wwmt_movepingsound_ui "" type:#string toolTip:"Move Ping Sound: A sound that is played more frequently as the train speeds up."
label wwmt_startsound_ui_label "Start Sound"  toolTip:"Start Sound: A sound played when the train starts moving."
editText wwmt_startsound_ui "" type:#string toolTip:"Start Sound: A sound played when the train starts moving."
label wwmt_stopsound_ui_label "Stop Sound"  toolTip:"Stop Sound: A sound played when the train stops moving."
editText wwmt_stopsound_ui "" type:#string toolTip:"Stop Sound: A sound played when the train stops moving."
spinner wwmt_volume_ui "Volume (10 = " type:#integer range:[-10000,10000,10]
spinner wwmt_movesoundminpitch_ui "Min pitch (1-" type:#integer range:[-10000,10000,60] toolTip:"Min pitch (1-255, > 100 = higher): The sound pitch value that the train will approach as it comes to a stop."
spinner wwmt_movesoundmaxpitch_ui "Max pitch (1-" type:#integer range:[-10000,10000,200] toolTip:"Max pitch (1-255, > 100 = higher): The sound pitch value that the train will approach as it approaches its +"
spinner wwmt_movesoundmintime_ui "Min move soun" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Min move sound interval: Minimum interval at which to play the move ping sound."
spinner wwmt_movesoundmaxtime_ui "Max move soun" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Max move sound interval: Maximum interval at which to play the move ping sound."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Pitch (X-rot)" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No User Control" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Fixed Orientation" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "HL1 Train" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use max speed for pitch shifting move sound" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Is unblockable by player" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tracktrain" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tracktrain_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tracktrain&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tracktrain" address:"https://developer.valvesoftware.com/wiki/func_tracktrain?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if velocitytype != undefined AND findItem propMapvelocitytype velocitytype == 0 then (
 append propMapvelocitytype velocitytype
tmp = wwmt_velocitytype_ui.items
 append tmp velocitytype
wwmt_velocitytype_ui.items = tmp
wwmt_velocitytype_ui.selection = propMapvelocitytype.count
) else ( 
 if velocitytype != undefined then (
wwmt_velocitytype_ui.selection = (findItem propMapvelocitytype velocitytype)
)
)
 if orientationtype != undefined AND findItem propMaporientationtype orientationtype == 0 then (
 append propMaporientationtype orientationtype
tmp = wwmt_orientationtype_ui.items
 append tmp orientationtype
wwmt_orientationtype_ui.items = tmp
wwmt_orientationtype_ui.selection = propMaporientationtype.count
) else ( 
 if orientationtype != undefined then (
wwmt_orientationtype_ui.selection = (findItem propMaporientationtype orientationtype)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_tanktrain_CA = attributes "WW Entity func_tanktrain" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_tanktrain"
local hasOutputs = true
local availableOutputs=#("OnDeath","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","DisableShadow","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","Resume","Reverse","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","SetSpeedDir","SetSpeedReal","StartBackward","StartForward","Stop","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValvelocitytype="0"
local propMapvelocitytype=#("0","1","2")
local propValorientationtype="1"
local propMaporientationtype=#("0","1","2","3")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("health","wwmt_target","startspeed","speed","velocitytype","orientationtype","wheels","height","bank","dmg","_minlight","movesound","movepingsound","startsound","stopsound","volume","movesoundminpitch","movesoundmaxpitch","movesoundmintime","movesoundmaxtime","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
health type:#integer ui:wwmt_health_ui default:100
wwmt_target type:#string ui:wwmt_target_ui default:""
startspeed type:#integer ui:wwmt_startspeed_ui default:100
speed type:#integer ui:wwmt_speed_ui default:0
velocitytype type:#string ui:wwmt_velocitytype_ui default:"0"
orientationtype type:#string ui:wwmt_orientationtype_ui default:"1"
wheels type:#integer ui:wwmt_wheels_ui default:50
height type:#integer ui:wwmt_height_ui default:4
bank type:#string ui:wwmt_bank_ui default:"0"
dmg type:#integer ui:wwmt_dmg_ui default:0
_minlight type:#string ui:wwmt__minlight_ui default:""
movesound type:#string ui:wwmt_movesound_ui default:""
movepingsound type:#string ui:wwmt_movepingsound_ui default:""
startsound type:#string ui:wwmt_startsound_ui default:""
stopsound type:#string ui:wwmt_stopsound_ui default:""
volume type:#integer ui:wwmt_volume_ui default:10
movesoundminpitch type:#integer ui:wwmt_movesoundminpitch_ui default:60
movesoundmaxpitch type:#integer ui:wwmt_movesoundmaxpitch_ui default:200
movesoundmintime type:#float ui:wwmt_movesoundmintime_ui default:0
movesoundmaxtime type:#float ui:wwmt_movesoundmaxtime_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_tanktrain"
spinner wwmt_health_ui "Health" type:#integer range:[-10000,10000,100]
label wwmt_target_ui_label "First Stop Target"  toolTip:"First Stop Target: The name of the first path_track in the train's path. The train +"
editText wwmt_target_ui "" type:#string toolTip:"First Stop Target: The name of the first path_track in the train's path. The train +"
pickbutton wwmt_target_pickme_ui "Pick First Stop Target" message:"Pick Target Entity for First Stop Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
spinner wwmt_startspeed_ui "Max Speed (un" type:#integer range:[-10000,10000,100] toolTip:"Max Speed (units / second): The maximum speed that this train can move. +"
spinner wwmt_speed_ui "Initial Speed" type:#integer range:[-10000,10000,0] toolTip:"Initial Speed (units / second): The speed that the train will move at after it spawns, 0 = stopped."
dropdownlist wwmt_velocitytype_ui "Change Velocity" type:#string items:#("Instantaneously","Linear blend","Ease in/ease out") toolTip:"Change Velocity: The method through which this train changes its velocity as it moves along the path. ="
on wwmt_velocitytype_ui selected i do velocitytype = propMapvelocitytype[i] 
dropdownlist wwmt_orientationtype_ui "Change angles" type:#string items:#("Never (fixed orientation)","Near path_tracks","Linear blend","Ease in/ease out") toolTip:"Change angles: The method through which this train changes its orientation as it moves along the path. ="
on wwmt_orientationtype_ui selected i do orientationtype = propMaporientationtype[i] 
spinner wwmt_wheels_ui "Distance Betw" type:#integer range:[-10000,10000,50] toolTip:"Distance Between the Wheels: Used for turning and stopping."
spinner wwmt_height_ui "Height above " type:#integer range:[-10000,10000,4] toolTip:"Height above track: The height above the track that this train moves."
label wwmt_bank_ui_label "Bank Angle on Turns" 
editText wwmt_bank_ui "" type:#string
spinner wwmt_dmg_ui "Damage on Cru" type:#integer range:[-10000,10000,0] toolTip:"Damage on Crush: The amount of damage this train does to entities that block it."
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
label wwmt_movesound_ui_label "Move Sound"  toolTip:"Move Sound: A sound that is played (and looped) while the train is moving."
editText wwmt_movesound_ui "" type:#string toolTip:"Move Sound: A sound that is played (and looped) while the train is moving."
label wwmt_movepingsound_ui_label "Move Ping Sound"  toolTip:"Move Ping Sound: A sound that is played more frequently as the train speeds up."
editText wwmt_movepingsound_ui "" type:#string toolTip:"Move Ping Sound: A sound that is played more frequently as the train speeds up."
label wwmt_startsound_ui_label "Start Sound"  toolTip:"Start Sound: A sound played when the train starts moving."
editText wwmt_startsound_ui "" type:#string toolTip:"Start Sound: A sound played when the train starts moving."
label wwmt_stopsound_ui_label "Stop Sound"  toolTip:"Stop Sound: A sound played when the train stops moving."
editText wwmt_stopsound_ui "" type:#string toolTip:"Stop Sound: A sound played when the train stops moving."
spinner wwmt_volume_ui "Volume (10 = " type:#integer range:[-10000,10000,10]
spinner wwmt_movesoundminpitch_ui "Min pitch (1-" type:#integer range:[-10000,10000,60] toolTip:"Min pitch (1-255, > 100 = higher): The sound pitch value that the train will approach as it comes to a stop."
spinner wwmt_movesoundmaxpitch_ui "Max pitch (1-" type:#integer range:[-10000,10000,200] toolTip:"Max pitch (1-255, > 100 = higher): The sound pitch value that the train will approach as it approaches its +"
spinner wwmt_movesoundmintime_ui "Min move soun" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Min move sound interval: Minimum interval at which to play the move ping sound."
spinner wwmt_movesoundmaxtime_ui "Max move soun" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Max move sound interval: Maximum interval at which to play the move ping sound."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "No Pitch (X-rot)" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "No User Control" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Passable" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Fixed Orientation" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "HL1 Train" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use max speed for pitch shifting move sound" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Is unblockable by player" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_tanktrain" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_tanktrain_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_tanktrain&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_tanktrain" address:"https://developer.valvesoftware.com/wiki/func_tanktrain?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if velocitytype != undefined AND findItem propMapvelocitytype velocitytype == 0 then (
 append propMapvelocitytype velocitytype
tmp = wwmt_velocitytype_ui.items
 append tmp velocitytype
wwmt_velocitytype_ui.items = tmp
wwmt_velocitytype_ui.selection = propMapvelocitytype.count
) else ( 
 if velocitytype != undefined then (
wwmt_velocitytype_ui.selection = (findItem propMapvelocitytype velocitytype)
)
)
 if orientationtype != undefined AND findItem propMaporientationtype orientationtype == 0 then (
 append propMaporientationtype orientationtype
tmp = wwmt_orientationtype_ui.items
 append tmp orientationtype
wwmt_orientationtype_ui.items = tmp
wwmt_orientationtype_ui.selection = propMaporientationtype.count
) else ( 
 if orientationtype != undefined then (
wwmt_orientationtype_ui.selection = (findItem propMaporientationtype orientationtype)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_traincontrols_CA = attributes "WW Entity func_traincontrols" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_traincontrols"
local hasOutputs = false
local hasInputs = false

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("wwmt_target","parentname","globalname")

parameters main rollout:params
(

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "func_traincontrols"
label wwmt_target_ui_label "Train Name"  toolTip:"Train Name: The target train to control when the player uses these controls."
editText wwmt_target_ui "" type:#string toolTip:"Train Name: The target train to control when the player uses these controls."
pickbutton wwmt_target_pickme_ui "Pick Train Name" message:"Pick Target Entity for Train Name" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_traincontrols" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_traincontrols_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_traincontrols&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_traincontrols" address:"https://developer.valvesoftware.com/wiki/func_traincontrols?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_autosave_CA = attributes "WW Entity trigger_autosave" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_autosave"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValnewlevelunit="0"
local propMapnewlevelunit=#("0","1")
local exportProps=#("master","newlevelunit","dangeroustimer","minimumhitpoints","targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
newlevelunit type:#string ui:wwmt_newlevelunit_ui default:"0"
dangeroustimer type:#float ui:wwmt_dangeroustimer_ui default:0
minimumhitpoints type:#integer ui:wwmt_minimumhitpoints_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "trigger_autosave"
label wwmt_master_ui_label "Master"  toolTip:"Master: The name of a master entity. If the master hasn't been activated, this entity will not activate."
editText wwmt_master_ui "" type:#string toolTip:"Master: The name of a master entity. If the master hasn't been activated, this entity will not activate."
dropdownlist wwmt_newlevelunit_ui "Force New Level Unit" type:#string items:#("No","Yes") toolTip:"Force New Level Unit: If set, the save will discard any savedata from previous levels, for the purpose of keeping savegame filesizes down. Can only be safely used if there is no way for the player to return to previous levels. ="
on wwmt_newlevelunit_ui selected i do newlevelunit = propMapnewlevelunit[i] 
spinner wwmt_dangeroustimer_ui "Dangerous Tim" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Dangerous Timer: The number of seconds the player must survive before this autosave takes effect."
spinner wwmt_minimumhitpoints_ui "Minumum Hit P" type:#integer range:[-10000,10000,0] toolTip:"Minumum Hit Points: Don't save dangerous when player has less than this many hitpoints."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_autosave" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_autosave_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_autosave&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_autosave" address:"https://developer.valvesoftware.com/wiki/trigger_autosave?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if newlevelunit != undefined AND findItem propMapnewlevelunit newlevelunit == 0 then (
 append propMapnewlevelunit newlevelunit
tmp = wwmt_newlevelunit_ui.items
 append tmp newlevelunit
wwmt_newlevelunit_ui.items = tmp
wwmt_newlevelunit_ui.selection = propMapnewlevelunit.count
) else ( 
 if newlevelunit != undefined then (
wwmt_newlevelunit_ui.selection = (findItem propMapnewlevelunit newlevelunit)
)
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_changelevel_CA = attributes "WW Entity trigger_changelevel" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_changelevel"
local hasOutputs = true
local availableOutputs=#("OnChangeLevel")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("ChangeLevel","Disable","Enable")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("targetname","map","landmark","startdisabled")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
map type:#string ui:wwmt_map_ui default:""
landmark type:#string ui:wwmt_landmark_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_changelevel"
label wwmt_targetname_ui_label "Name" 
editText wwmt_targetname_ui "" type:#string
label wwmt_map_ui_label "New Map Name" 
editText wwmt_map_ui "" type:#string
label wwmt_landmark_ui_label "Landmark Name" 
editText wwmt_landmark_ui "" type:#string
pickbutton wwmt_landmark_pickme_ui "Pick Landmark Name" message:"Pick Target Entity for Landmark Name" filter:target_name_filter 
on wwmt_landmark_pickme_ui picked obj do (
landmark = obj.targetname
) 
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "Disable Touch" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "To Previous Chapter" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_changelevel" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_changelevel_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_changelevel&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_changelevel" address:"https://developer.valvesoftware.com/wiki/trigger_changelevel?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_gravity_CA = attributes "WW Entity trigger_gravity" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_gravity"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("gravity","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
gravity type:#integer ui:wwmt_gravity_ui default:1
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_gravity"
spinner wwmt_gravity_ui "Gravity (0-1)" type:#integer range:[-10000,10000,1]
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_gravity" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_gravity_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_gravity&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_gravity" address:"https://developer.valvesoftware.com/wiki/trigger_gravity?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_playermovement_CA = attributes "WW Entity trigger_playermovement" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_playermovement"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_playermovement"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_16_ui "(OBSOLETE, Uncheck me)" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_128_ui "Disable auto player movement" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Auto-duck while in trigger" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_playermovement" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_playermovement_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_playermovement&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_playermovement" address:"https://developer.valvesoftware.com/wiki/trigger_playermovement?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_soundscape_CA = attributes "WW Entity trigger_soundscape" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_soundscape"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("soundscape","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
soundscape type:#string ui:wwmt_soundscape_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_soundscape"
label wwmt_soundscape_ui_label "Soundscape" 
editText wwmt_soundscape_ui "" type:#string
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_soundscape" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_soundscape_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_soundscape&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_soundscape" address:"https://developer.valvesoftware.com/wiki/trigger_soundscape?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_hurt_CA = attributes "WW Entity trigger_hurt" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_hurt"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnHurt","OnHurtPlayer","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetDamage","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValdamagetype="0"
local propMapdamagetype=#("0","1","2","4","8","16","32","64","128","256","512","1024","16384","32768","65536","131072","262144","524288","1048576","2097152","4194304")
local propValdamagemodel="0"
local propMapdamagemodel=#("0","1")
local propValnodmgforce="0"
local propMapnodmgforce=#("0","1")
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("master","damage","damagecap","damagetype","damagemodel","nodmgforce","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
master type:#string ui:wwmt_master_ui default:""
damage type:#integer ui:wwmt_damage_ui default:10
damagecap type:#integer ui:wwmt_damagecap_ui default:20
damagetype type:#string ui:wwmt_damagetype_ui default:"0"
damagemodel type:#string ui:wwmt_damagemodel_ui default:"0"
nodmgforce type:#string ui:wwmt_nodmgforce_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_hurt"
label wwmt_master_ui_label "Master (Obsolete)"  toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this entity will not activate."
editText wwmt_master_ui "" type:#string toolTip:"Master (Obsolete): The name of a master entity. If the master hasn't been activated, this entity will not activate."
spinner wwmt_damage_ui "Damage" type:#integer range:[-10000,10000,10] toolTip:"Damage: The amount of damage done to entities that touch this trigger. The damage is done every half-second. See also 'Damage Model' for extra details on how damage can be dealt."
spinner wwmt_damagecap_ui "Damage Cap" type:#integer range:[-10000,10000,20] toolTip:"Damage Cap: Maximum damage dealt per second. This field is only used if you select the Doubling w/Forgiveness damage model, via the spawnflag."
dropdownlist wwmt_damagetype_ui "Damage Type" type:#string items:#("GENERIC","CRUSH","BULLET","SLASH","BURN","FREEZE","FALL","BLAST","CLUB","SHOCK","SONIC","ENERGYBEAM","DROWN","PARALYSE","NERVEGAS","POISON","RADIATION","DROWNRECOVER","CHEMICAL","SLOWBURN","SLOWFREEZE")
on wwmt_damagetype_ui selected i do damagetype = propMapdamagetype[i] 
dropdownlist wwmt_damagemodel_ui "Damage Model" type:#string items:#("Normal","Doubling w/forgiveness") toolTip:"Damage Model: How damage is dealt. Normal always does the specified amount of damage each half second. Doubling starts with the specified amount and doubles it each time it hurts the toucher. Forgiveness means that if the toucher gets out of the trigger the damage will reset to the specified value. Good for making triggers that are deadly over time without having to cause massive damage on each touch. ="
on wwmt_damagemodel_ui selected i do damagemodel = propMapdamagemodel[i] 
dropdownlist wwmt_nodmgforce_ui "Zero Damage Force" type:#string items:#("No","Yes") toolTip:"Zero Damage Force: Should the damaged entity receive no physics force from this trigger. ="
on wwmt_nodmgforce_ui selected i do nodmgforce = propMapnodmgforce[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_hurt" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_hurt_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_hurt&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_hurt" address:"https://developer.valvesoftware.com/wiki/trigger_hurt?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if damagetype != undefined AND findItem propMapdamagetype damagetype == 0 then (
 append propMapdamagetype damagetype
tmp = wwmt_damagetype_ui.items
 append tmp damagetype
wwmt_damagetype_ui.items = tmp
wwmt_damagetype_ui.selection = propMapdamagetype.count
) else ( 
 if damagetype != undefined then (
wwmt_damagetype_ui.selection = (findItem propMapdamagetype damagetype)
)
)
 if damagemodel != undefined AND findItem propMapdamagemodel damagemodel == 0 then (
 append propMapdamagemodel damagemodel
tmp = wwmt_damagemodel_ui.items
 append tmp damagemodel
wwmt_damagemodel_ui.items = tmp
wwmt_damagemodel_ui.selection = propMapdamagemodel.count
) else ( 
 if damagemodel != undefined then (
wwmt_damagemodel_ui.selection = (findItem propMapdamagemodel damagemodel)
)
)
 if nodmgforce != undefined AND findItem propMapnodmgforce nodmgforce == 0 then (
 append propMapnodmgforce nodmgforce
tmp = wwmt_nodmgforce_ui.items
 append tmp nodmgforce
wwmt_nodmgforce_ui.items = tmp
wwmt_nodmgforce_ui.selection = propMapnodmgforce.count
) else ( 
 if nodmgforce != undefined then (
wwmt_nodmgforce_ui.selection = (findItem propMapnodmgforce nodmgforce)
)
)
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_remove_CA = attributes "WW Entity trigger_remove" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_remove"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnRemove","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_remove"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_remove" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_remove_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_remove&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_remove" address:"https://developer.valvesoftware.com/wiki/trigger_remove?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_multiple_CA = attributes "WW Entity trigger_multiple" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_multiple"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnNotTouching","OnStartTouch","OnStartTouchAll","OnTouching","OnTrigger","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle","TouchTest")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("wait","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wait type:#integer ui:wwmt_wait_ui default:1
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_multiple"
spinner wwmt_wait_ui "Delay Before " type:#integer range:[-10000,10000,1] toolTip:"Delay Before Reset: Amount of time, in seconds, after the trigger_multiple has triggered before it can be triggered again. If set to -1, it will never trigger again (in which case you should just use a trigger_once)."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_multiple" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_multiple_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_multiple&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_multiple" address:"https://developer.valvesoftware.com/wiki/trigger_multiple?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_once_CA = attributes "WW Entity trigger_once" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_once"
local hasOutputs = true
local availableOutputs=#("OnStartTouch","OnTrigger","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("filtername","targetname","parentname","origin","startdisabled","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
filtername type:#string ui:wwmt_filtername_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_once"
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_once" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_once_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_once&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_once" address:"https://developer.valvesoftware.com/wiki/trigger_once?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_look_CA = attributes "WW Entity trigger_look" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_look"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnTimeout","OnTrigger","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("wwmt_target","looktime","fieldofview","timeout","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
looktime type:#string ui:wwmt_looktime_ui default:"0.5"
fieldofview type:#string ui:wwmt_fieldofview_ui default:"0.9"
timeout type:#float ui:wwmt_timeout_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_look"
label wwmt_target_ui_label "Look Target"  toolTip:"Look Target: The name of the entity to be looked at."
editText wwmt_target_ui "" type:#string toolTip:"Look Target: The name of the entity to be looked at."
pickbutton wwmt_target_pickme_ui "Pick Look Target" message:"Pick Target Entity for Look Target" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_looktime_ui_label "LookTime"  toolTip:"LookTime: The time, in seconds, that the player must look the target before firing the output. Resets if player leaves trigger, or looks outside the Field of View threshold."
editText wwmt_looktime_ui "" type:#string toolTip:"LookTime: The time, in seconds, that the player must look the target before firing the output. Resets if player leaves trigger, or looks outside the Field of View threshold."
label wwmt_fieldofview_ui_label "FieldOfView"  toolTip:"FieldOfView: How close the player has to be looking at the target. 1.0 = straight ahead\n 0.0 = +/- 90 degrees\n -1.0 = all directions)."
editText wwmt_fieldofview_ui "" type:#string toolTip:"FieldOfView: How close the player has to be looking at the target. 1.0 = straight ahead\n 0.0 = +/- 90 degrees\n -1.0 = all directions)."
spinner wwmt_timeout_ui "Timeout" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Timeout: The time, in seconds, to wait after player enters the trigger before firing the OnTimeout output, 0 = never."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_128_ui "Fire Once" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Use Velocity instead of facing" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_look" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_look_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_look&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_look" address:"https://developer.valvesoftware.com/wiki/trigger_look?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_push_CA = attributes "WW Entity trigger_push" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_push"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("pushdir","speed","alternateticksfix","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
pushdir type:#string ui:wwmt_pushdir_ui default:"0 0 0"
speed type:#integer ui:wwmt_speed_ui default:40
alternateticksfix type:#float ui:wwmt_alternateticksfix_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_push"
label wwmt_pushdir_ui_label "Push Direction (Pitch Yaw Roll)"  toolTip:"Push Direction (Pitch Yaw Roll): Angles indicating the direction to push touched entities."
editText wwmt_pushdir_ui "" type:#string toolTip:"Push Direction (Pitch Yaw Roll): Angles indicating the direction to push touched entities."
spinner wwmt_speed_ui "Speed of Push" type:#integer range:[-10000,10000,40] toolTip:"Speed of Push: The speed at which to push entities away, in inches / second."
spinner wwmt_alternateticksfix_ui "Scale force f" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Scale force for alternate ticks: If nonzero, scale the force by this amount when running with alternate ticks. This fixes problems with an overly large force due to the longer frametime on when running with sv_alternateticks 1."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_128_ui.checked == true then (
sfs+=128
)
if params.flag_256_ui.checked == true then (
sfs+=256
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_128_ui "Once Only" type:#integer

on flag_128_ui changed theState do (
addFlags()
)
checkbox flag_256_ui "Affects Ladders (Half-Life 2)" type:#integer

on flag_256_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_push" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_push_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_push&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_push" address:"https://developer.valvesoftware.com/wiki/trigger_push?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 128 == 128 then (
flag_128_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 256 == 256 then (
flag_256_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_wind_CA = attributes "WW Entity trigger_wind" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_wind"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","SetSpeed","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("speed","speednoise","directionnoise","holdtime","holdnoise","targetname","parentname","origin","startdisabled","filtername","globalname","angles")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
speed type:#integer ui:wwmt_speed_ui default:200
speednoise type:#integer ui:wwmt_speednoise_ui default:0
directionnoise type:#integer ui:wwmt_directionnoise_ui default:10
holdtime type:#integer ui:wwmt_holdtime_ui default:0
holdnoise type:#integer ui:wwmt_holdnoise_ui default:0
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_wind"
spinner wwmt_speed_ui "Speed" type:#integer range:[-10000,10000,200] toolTip:"Speed: The baseline for how hard the wind blows."
spinner wwmt_speednoise_ui "Speed Noise" type:#integer range:[-10000,10000,0] toolTip:"Speed Noise: Noise added to wind speed +/-"
spinner wwmt_directionnoise_ui "Direction Noi" type:#integer range:[-10000,10000,10] toolTip:"Direction Noise: Noise added to wind direction."
spinner wwmt_holdtime_ui "Hold Time" type:#integer range:[-10000,10000,0] toolTip:"Hold Time: Baseline for how long to wait before changing wind."
spinner wwmt_holdnoise_ui "Hold Noise" type:#integer range:[-10000,10000,0] toolTip:"Hold Noise: Noise added to how long to wait before changing wind."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_wind" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_wind_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_wind&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_wind" address:"https://developer.valvesoftware.com/wiki/trigger_wind?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_impact_CA = attributes "WW Entity trigger_impact" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_impact"
local hasOutputs = true
local availableOutputs=#("ImpactForce","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Impact","Kill","KillHierarchy","SetMagnitude")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("magnitude","noise","viewkick","targetname","origin","angles")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
magnitude type:#float ui:wwmt_magnitude_ui default:200
noise type:#float ui:wwmt_noise_ui default:0.1
viewkick type:#float ui:wwmt_viewkick_ui default:0.05
targetname type:#string ui:wwmt_targetname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
angles type:#string ui:wwmt_angles_ui default:"0 0 0"

)
rollout params "Entity Properties"
(
label entityLabel "trigger_impact"
spinner wwmt_magnitude_ui "Magnitude" type:#float scale:0.001 range:[-10000.000,10000.000,200] toolTip:"Magnitude: The strength of the impact. Negative values reverse the direction."
spinner wwmt_noise_ui "Noise" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Noise: The amount of directional noise (0-1). 0 = no noise, 1 = random direction."
spinner wwmt_viewkick_ui "Viewkick" type:#float scale:0.001 range:[-10000.000,10000.000,0] toolTip:"Viewkick: The amount to kick player's view if the player is in the trigger. Proportional to magnitude (0-1)."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
label wwmt_angles_ui_label "Pitch Yaw Roll (Y Z X)"  toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"
editText wwmt_angles_ui "" type:#string toolTip:"Pitch Yaw Roll (Y Z X): This entity's orientation in the world. Pitch is rotation around the Y axis, +"

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_impact" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_impact_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_impact&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_impact" address:"https://developer.valvesoftware.com/wiki/trigger_impact?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_proximity_CA = attributes "WW Entity trigger_proximity" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_proximity"
local hasOutputs = true
local availableOutputs=#("NearestEntityDistance","OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("measuretarget","radius","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
measuretarget type:#string ui:wwmt_measuretarget_ui default:""
radius type:#string ui:wwmt_radius_ui default:"256"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_proximity"
label wwmt_measuretarget_ui_label "Point to Measure From"  toolTip:"Point to Measure From: The name of a target entity who's origin is the point to measure the player's distance from."
editText wwmt_measuretarget_ui "" type:#string toolTip:"Point to Measure From: The name of a target entity who's origin is the point to measure the player's distance from."
pickbutton wwmt_measuretarget_pickme_ui "Pick Point to Measure From" message:"Pick Target Entity for Point to Measure From" filter:target_name_filter 
on wwmt_measuretarget_pickme_ui picked obj do (
measuretarget = obj.targetname
) 
label wwmt_radius_ui_label "Radius to measure within"  toolTip:"Radius to measure within: The radius to which the distance should be mapped. If the player is outside the radius he will be ignored."
editText wwmt_radius_ui "" type:#string toolTip:"Radius to measure within: The radius to which the distance should be mapped. If the player is outside the radius he will be ignored."
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_32_ui "Only clients in vehicles" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_proximity" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_proximity_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_proximity&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_proximity" address:"https://developer.valvesoftware.com/wiki/trigger_proximity?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_teleport_CA = attributes "WW Entity trigger_teleport" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_teleport"
local hasOutputs = true
local availableOutputs=#("OnEndTouch","OnEndTouchAll","OnStartTouch","OnStartTouchAll","OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","ClearParent","Disable","Enable","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset","Toggle")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local exportProps=#("wwmt_target","landmark","targetname","parentname","origin","startdisabled","filtername","globalname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
wwmt_target type:#string ui:wwmt_target_ui default:""
landmark type:#string ui:wwmt_landmark_ui default:""
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
filtername type:#string ui:wwmt_filtername_ui default:""
globalname type:#string ui:wwmt_globalname_ui default:""
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "trigger_teleport"
label wwmt_target_ui_label "Remote Destination"  toolTip:"Remote Destination: The entity specifying the point to which entities should be teleported."
editText wwmt_target_ui "" type:#string toolTip:"Remote Destination: The entity specifying the point to which entities should be teleported."
pickbutton wwmt_target_pickme_ui "Pick Remote Destination" message:"Pick Target Entity for Remote Destination" filter:target_name_filter 
on wwmt_target_pickme_ui picked obj do (
wwmt_target = obj.targetname
) 
label wwmt_landmark_ui_label "Local Destination Landmark"  toolTip:"Local Destination Landmark: If specified, then teleported entities are offset from the target by their initial offset from the landmark."
editText wwmt_landmark_ui "" type:#string toolTip:"Local Destination Landmark: If specified, then teleported entities are offset from the target by their initial offset from the landmark."
pickbutton wwmt_landmark_pickme_ui "Pick Local Destination Landmark" message:"Pick Target Entity for Local Destination Landmark" filter:target_name_filter 
on wwmt_landmark_pickme_ui picked obj do (
landmark = obj.targetname
) 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
label wwmt_filtername_ui_label "Filter Name"  toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
editText wwmt_filtername_ui "" type:#string toolTip:"Filter Name: Filter to use to see if activator triggers me. See filter_activator_name for more explanation."
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."

function addFlags = (
 local sfs = 0

if params.flag_32_ui.checked == true then (
sfs+=32
)
if params.flag_1_ui.checked == true then (
sfs+=1
)
if params.flag_2_ui.checked == true then (
sfs+=2
)
if params.flag_4_ui.checked == true then (
sfs+=4
)
if params.flag_8_ui.checked == true then (
sfs+=8
)
if params.flag_16_ui.checked == true then (
sfs+=16
)
if params.flag_64_ui.checked == true then (
sfs+=64
)
if params.flag_512_ui.checked == true then (
sfs+=512
)
if params.flag_1024_ui.checked == true then (
sfs+=1024
)
if params.flag_2048_ui.checked == true then (
sfs+=2048
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_32_ui "Preserve angles even when a local landmark is not specified" type:#integer

on flag_32_ui changed theState do (
addFlags()
)
checkbox flag_1_ui "Clients" type:#integer

on flag_1_ui changed theState do (
addFlags()
)
checkbox flag_2_ui "NPCs" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
checkbox flag_4_ui "Pushables" type:#integer

on flag_4_ui changed theState do (
addFlags()
)
checkbox flag_8_ui "Physics Objects" type:#integer

on flag_8_ui changed theState do (
addFlags()
)
checkbox flag_16_ui "Only player ally NPCs" type:#integer

on flag_16_ui changed theState do (
addFlags()
)
checkbox flag_64_ui "Everything (not including physics debris)" type:#integer

on flag_64_ui changed theState do (
addFlags()
)
checkbox flag_512_ui "Only clients *not* in vehicles" type:#integer

on flag_512_ui changed theState do (
addFlags()
)
checkbox flag_1024_ui "Physics debris" type:#integer

on flag_1024_ui changed theState do (
addFlags()
)
checkbox flag_2048_ui "Only NPCs in vehicles (respects player ally flag)" type:#integer

on flag_2048_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_teleport" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_teleport_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_teleport&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_teleport" address:"https://developer.valvesoftware.com/wiki/trigger_teleport?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)

if bit.and (getProperty this "spawnflags") 32 == 32 then (
flag_32_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1 == 1 then (
flag_1_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 4 == 4 then (
flag_4_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 8 == 8 then (
flag_8_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 16 == 16 then (
flag_16_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 64 == 64 then (
flag_64_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 512 == 512 then (
flag_512_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 1024 == 1024 then (
flag_1024_ui.checked = true
)

if bit.and (getProperty this "spawnflags") 2048 == 2048 then (
flag_2048_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_transition_CA = attributes "WW Entity trigger_transition" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_transition"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "trigger_transition"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_transition" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_transition_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_transition&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_transition" address:"https://developer.valvesoftware.com/wiki/trigger_transition?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_trigger_serverragdoll_CA = attributes "WW Entity trigger_serverragdoll" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="trigger_serverragdoll"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local exportProps=#("targetname")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
targetname type:#string ui:wwmt_targetname_ui default:""

)
rollout params "Entity Properties"
(
label entityLabel "trigger_serverragdoll"
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with trigger_serverragdoll" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"trigger_serverragdoll_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=trigger_serverragdoll&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: trigger_serverragdoll" address:"https://developer.valvesoftware.com/wiki/trigger_serverragdoll?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)

global wallworm_func_reflective_glass_CA = attributes "WW Entity func_reflective_glass" version:57
(
local wallworm=true
local entityType="SolidClass"
local isWWPRO = false
local thisNode = undefined
local entname="func_reflective_glass"
local hasOutputs = true
local availableOutputs=#("OnUser1","OnUser2","OnUser3","OnUser4")
local hasInputs = true
local currentInputs=#()
 local availableInputs=#("AddOutput","Alpha","ClearParent","Color","Disable","DisableShadow","Enable","EnableShadow","FireUser1","FireUser2","FireUser3","FireUser4","Kill","KillHierarchy","SetExcluded","SetInvert","SetParent","SetParentAttachment","SetParentAttachmentMaintainOffset")

	 function getNode = (
		if NOT isValidNode thisNode  then (
			thisNode = refs.dependentnodes (custAttributes.getOwner this) firstonly:on	
		)
	thisNode
	)

	function hasOutputFor obj = ( 
		local out = false 
		if NOT isProperty obj #outputs OR obj.outputs.count == 0  then ( 
			out = false 
		) 
		else 
		( 
			for o in obj.outputs while out == false do ( 
				local theOutputAr  = filterString o ">" splitEmptyTokens:true
				if theOutputAr == undefined OR theOutputAr.count < 2 OR theOutputAr[2] == undefined OR theOutputAr[2] == "" then (
				) else (
					local targName = ""
					local thisentname = undefined
					if isProperty this #targetname != false then (
						targName = (getProperty this #targetname) as string
						thisentname = (getProperty this #entname) as string
						if theOutputAr[2] == targName OR  theOutputAr[2] ==thisentname OR  matchPattern  thisentname pattern:theOutputAr[2] == true OR ( targName != "" AND matchPattern  targName pattern:theOutputAr[2] == true) then (
							out = true
						)
					)
				)
			)
		)
		out
	)

	function getMyInputs =
	(
		disableRefMsgs()
		if hasInputs == true then
		(
			currentInputs = for obj in objects WHERE isProperty obj #hasOutputs AND isProperty obj #outputs AND  isProperty obj #wallworm  AND obj.outputs.count > 0 AND (hasOutputFor obj) == true collect obj
		)
		enableRefMsgs()
		return currentInputs
	)

fn target_name_filter obj = (
if (  isProperty obj #targetname AND isProperty obj #wallworm AND obj.targetname != undefined AND obj.targetname != "") then  true else  false)
function updateBrushNodeList nodelist= (
if nodelist != undefined then (
for obj in nodelist collect obj.name
)
)

fn target_node_filter obj = superClassOf obj == GeometryClass
local propValsolidity="0"
local propMapsolidity=#("0","1","2")
local propValinvert_exclusion="0"
local propMapinvert_exclusion=#("0","1")
local propValsolidbsp="0"
local propMapsolidbsp=#("0","1")
local propValvrad_brush_cast_shadows="0"
local propMapvrad_brush_cast_shadows=#("0","1")
local propValrendermode="0"
local propMaprendermode=#("0","1","2","3","4","5","7","9","10")
local propValdisablereceiveshadows="0"
local propMapdisablereceiveshadows=#("0","1")
local propValrenderfx="0"
local propMaprenderfx=#("0","1","2","3","4","9","10","11","12","13","5","6","7","8","14","15","16","23","24","26")
local propValinputfilter="0"
local propMapinputfilter=#("0","8","16","32")
local propValstartdisabled="0"
local propMapstartdisabled=#("0","1")
local propValdisableshadows="0"
local propMapdisableshadows=#("0","1")
local exportProps=#("_minlight","solidity","excludednpc","invert_exclusion","solidbsp","vrad_brush_cast_shadows","targetname","parentname","origin","rendermode","renderamt","rendercolor","disablereceiveshadows","renderfx","globalname","inputfilter","startdisabled","disableshadows")

parameters main rollout:params
(

outputs type:#stringTab  tabSizeVariable:true

brushNodes type:#nodeTab  tabSizeVariable:true
_minlight type:#string ui:wwmt__minlight_ui default:""
solidity type:#string ui:wwmt_solidity_ui default:"0"
excludednpc type:#string ui:wwmt_excludednpc_ui default:""
invert_exclusion type:#string ui:wwmt_invert_exclusion_ui default:"0"
solidbsp type:#string ui:wwmt_solidbsp_ui default:"0"
vrad_brush_cast_shadows type:#string ui:wwmt_vrad_brush_cast_shadows_ui default:"0"
targetname type:#string ui:wwmt_targetname_ui default:""
parentname type:#string ui:wwmt_parentname_ui default:""
origin type:#string ui:wwmt_origin_ui default:""
rendermode type:#string ui:wwmt_rendermode_ui default:"0"
renderamt type:#integer ui:wwmt_renderamt_ui default:255
rendercolor type:#color ui:wwmt_rendercolor_ui default:( color 255 255 255 )
rendercolor_intensity type:#integer ui:wwmt_rendercolor_inensity_ui default:20
disablereceiveshadows type:#string ui:wwmt_disablereceiveshadows_ui default:"0"
renderfx type:#string ui:wwmt_renderfx_ui default:"0"
globalname type:#string ui:wwmt_globalname_ui default:""
inputfilter type:#string ui:wwmt_inputfilter_ui default:"0"
startdisabled type:#string ui:wwmt_startdisabled_ui default:"0"
disableshadows type:#string ui:wwmt_disableshadows_ui default:"0"
spawnflags type:#integer default:0

)
rollout params "Entity Properties"
(
label entityLabel "func_reflective_glass"
label wwmt__minlight_ui_label "Minimum Light Level"  toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
editText wwmt__minlight_ui "" type:#string toolTip:"Minimum Light Level: The minimum level of ambient light that hits this brush."
dropdownlist wwmt_solidity_ui "Solidity" type:#string items:#("Toggle","Never Solid","Always Solid") toolTip:"Solidity: Used to control the solidity/collision of these brushes. ="
on wwmt_solidity_ui selected i do solidity = propMapsolidity[i] 
label wwmt_excludednpc_ui_label "NPC class excluded from collisions"  toolTip:"NPC class excluded from collisions: If an NPC classname is specified here, NPCs of that type won't collide with these brushes. In Episodic, you may also specify an individual entity's name."
editText wwmt_excludednpc_ui "" type:#string toolTip:"NPC class excluded from collisions: If an NPC classname is specified here, NPCs of that type won't collide with these brushes. In Episodic, you may also specify an individual entity's name."
dropdownlist wwmt_invert_exclusion_ui "Invert NPC class exclusion" type:#string items:#("No","Yes") toolTip:"Invert NPC class exclusion: If set, then the excluded NPC class will consider this brush solid, and all other NPC classes will consider it non-solid. ="
on wwmt_invert_exclusion_ui selected i do invert_exclusion = propMapinvert_exclusion[i] 
dropdownlist wwmt_solidbsp_ui "Solid BSP" type:#string items:#("No","Yes") toolTip:"Solid BSP: Set this if this brush is in heirarchy with a moving object of some kind, and the player can stand on this brush. ="
on wwmt_solidbsp_ui selected i do solidbsp = propMapsolidbsp[i] 
dropdownlist wwmt_vrad_brush_cast_shadows_ui "Shadows" type:#string items:#("No","Yes") toolTip:"Shadows: Set this if this brush casts lightmap shadows. ="
on wwmt_vrad_brush_cast_shadows_ui selected i do vrad_brush_cast_shadows = propMapvrad_brush_cast_shadows[i] 
label wwmt_targetname_ui_label "Name"  toolTip:"Name: The name that other entities refer to this entity by."
editText wwmt_targetname_ui "" type:#string toolTip:"Name: The name that other entities refer to this entity by."
label wwmt_parentname_ui_label "Parent"  toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
editText wwmt_parentname_ui "" type:#string toolTip:"Parent: The name of this entity's parent in the movement hierarchy. Entities with parents move with their parent."
pickbutton wwmt_parentname_pickme_ui "Pick Parent" message:"Pick Target Entity for Parent" filter:target_name_filter 
on wwmt_parentname_pickme_ui picked obj do (
parentname = obj.targetname
) 
label wwmt_origin_ui_label "Origin (X Y Z)"  toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
editText wwmt_origin_ui "" type:#string toolTip:"Origin (X Y Z): The position of this entity's center in the world. Rotating entities typically rotate around their origin."
dropdownlist wwmt_rendermode_ui "Render Mode" type:#string items:#("Normal","Color","Texture","Glow","Solid","Additive","Additive Fractional Frame","World Space Glow","Dont Render") toolTip:"Render Mode: Used to set a non-standard rendering mode on this entity. See also 'FX Amount' and 'FX Color'. ="
on wwmt_rendermode_ui selected i do rendermode = propMaprendermode[i] 
spinner wwmt_renderamt_ui "FX Amount (0 " type:#integer range:[-10000,10000,255] toolTip:"FX Amount (0 - 255): The FX amount is used by the selected Render Mode."
colorPicker wwmt_rendercolor_ui "FX Color (R G B)" color:( color 255 255 255 ) toolTip:"FX Color (R G B): The FX color is used by the selected Render Mode."
spinner wwmt_rendercolor_inensity_ui "FX Color (R G B) Intensity"  type:#integer range:[-16000,16000,20] tooltip:"Intensity for FX Color (R G B)"
dropdownlist wwmt_disablereceiveshadows_ui "Disable Receiving Shadows" type:#string items:#("No","Yes")
on wwmt_disablereceiveshadows_ui selected i do disablereceiveshadows = propMapdisablereceiveshadows[i] 
dropdownlist wwmt_renderfx_ui "Render FX" type:#string items:#("Normal","Slow Pulse","Fast Pulse","Slow Wide Pulse","Fast Wide Pulse","Slow Strobe","Fast Strobe","Faster Strobe","Slow Flicker","Fast Flicker","Slow Fade Away","Fast Fade Away","Slow Become Solid","Fast Become Solid","Constant Glow","Distort","Hologram (Distort + fade)","Cull By Distance (TEST)","Spotlight FX","Fade Near")
on wwmt_renderfx_ui selected i do renderfx = propMaprenderfx[i] 
label wwmt_globalname_ui_label "Global Entity Name"  toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
editText wwmt_globalname_ui "" type:#string toolTip:"Global Entity Name: Name by which this entity is linked to another entity in a different map. When the player transitions to a new map, entities in the new map with globalnames matching entities in the previous map will have the previous map's state copied over their state."
dropdownlist wwmt_inputfilter_ui "Input Filter" type:#string items:#("Allow all inputs","Ignore Touch/Untouch","Ignore Use","Ignore All") toolTip:"Input Filter: Used to specify which inputs this entity will accept. ="
on wwmt_inputfilter_ui selected i do inputfilter = propMapinputfilter[i] 
dropdownlist wwmt_startdisabled_ui "Start Disabled" type:#string items:#("No","Yes")
on wwmt_startdisabled_ui selected i do startdisabled = propMapstartdisabled[i] 
dropdownlist wwmt_disableshadows_ui "Disable shadows" type:#string items:#("No","Yes")
on wwmt_disableshadows_ui selected i do disableshadows = propMapdisableshadows[i] 

function addFlags = (
 local sfs = 0

if params.flag_2_ui.checked == true then (
sfs+=2
)
setProperty this "spawnflags" sfs
)

group "Spawn Flags"
(

checkbox flag_2_ui "Ignore player +USE" type:#integer

on flag_2_ui changed theState do (
addFlags()
)
)

group "Included Nodes"
(
pickbutton wwmt_add_brush_entity "Add Brush to Entity" message:"Pick  Node to include with func_reflective_glass" filter:target_node_filter 
listbox entityGroupList "Included Objects"on wwmt_add_brush_entity picked obj do (
 if brushNodes == undefined then (
brushNodes = #()
)
 appendIfUnique brushNodes obj
entityGroupList.items = (updateBrushNodeList brushNodes)
) 
on entityGroupList selected ind do ( if ind != 0 then (
 flashnodes (#(brushNodes[ind])))
) 
button removeBrushNode "Remove Selected Object"
button groupBrushNode "Group Nodes"
on groupBrushNode pressed do (
 if brushNodes != undefined AND brushNodes.count > 0 then (
 objList = #((refs.dependentnodes (custAttributes.getOwner this) firstonly:on))
join objList brushNodes
group objList prefix:"func_reflective_glass_")
) 
on removeBrushNode pressed do (
 if entityGroupList.selection != 0 then (
deleteItem brushNodes entityGroupList.selection
entityGroupList.items = updateBrushNodeList brushNodes)
) 

)

fn input_filter_func obj = isProperty obj #availableInputs

group "Outputs"
(
button addOutput "Add New Output" tooltip:"Add a new blank Output into the Output list below. After creation, set the parameters below."
combobox outputs_ui "Current List"
button deleteOutput "Remove Selected Output" tooltip:"Delete the currently selected output in the list above."
dropdownlist outputName "Output" items:availableOutputs
editText outputTargetName "Target" tooltip:"Enter the targetname or target classname for this output."
pickbutton getInputs "Pick Target" filter:input_filter_func tooltip:"Pick an entity in the scene. Only those with Inputs will work."
combobox outputInput "Via This Input"
editText outputParamOverride "Value"
spinner outputDelay "Delay" range:[0,16000,0]
spinner outputFireLimit "Times to Fire" type:#integer range:[-1,16000,-1]

)

function getCurrentInputs tex = (
	if tex != "" then (
		for obj in objects WHERE isProperty obj #hasInputs AND isProperty obj #wallworm  AND obj.hasInputs == true AND (
			matchPattern obj.entname pattern:tex OR (isProperty obj #targetname AND matchPattern obj.targetname pattern:tex)
		) collect obj
	) else (
		 #()
	)
)
function updateInputListFromObjs objs = (
theAr= for obj in objs collect obj.availableInputs 
theArCondensed=#()
for inpItem in theAr do (for InpItem2 in inpItem do (appendIfUnique theArCondensed InpItem2))
 sort theArCondensed 
outputInput.items  = theArCondensed

)
function setOutputsUIfromOutput str = (
if str != undefined AND str != "" then (
local inpAr = filterString str ">" splitEmptyTokens:true
local fireVal = undefined 
local delayVal = undefined 
if inpAr.count > 0 then (
outName = trimLeft (trimRight inpAr[1])  
if outName != "" AND outputName.items != undefined AND findItem outputName.items outName == 0 then (
temp = outputName.items
appendIfUnique temp (outName as string) 
outputName.items=temp 
)    
if  outputName.items != undefined then ( 
outputName.selection=findItem outputName.items outName 
) 
if inpAr[2] != undefined then (
outputTargetName.text=inpAr[2]
)  
if inpAr[3] != undefined then (
local theEffected = getCurrentInputs outputTargetName.text 
if theEffected != undefined then ( 
updateInputListFromObjs theEffected 
) 
temp = outputInput.items
appendIfUnique temp (inpAr[3] as string) 
outputInput.items=temp
if outputInput.items != undefined then (
outputInput.selection = findItem outputInput.items inpAr[3]
) 
)  
if  inpAr[4] != undefined then (
outputParamOverride.text = inpAr[4]
) 
if inpAr[5] != undefined then ( 
delayVal = inpAr[5] 
)   
if delayVal != undefined  then (
outputDelay.value = delayVal as float 
)  
if  inpAr[6] != undefined then  (
fireVal = inpAr[6] as integer
)
if fireVal != undefined then (
outputFireLimit.value = fireVal
)    
) 
) 
)
function setOutputsFromOutputUI = (
if outputs_ui.selection != 0 then (
local outputStr = (outputName.text+">"+outputTargetName.text+">"+outPutInput.text+">"+outputParamOverride.text+">"+(outputDelay.value as string)+">"+(outputFireLimit.value as string))
 theOP = getProperty this #outputs
theOP[outputs_ui.selection] = outputStr
setProperty this #outputs theOP
outputs_ui.items = theOP as array
) else (
messagebox "You need to select an output before editing. If there are none, add one with the add button."
)
)
on outputDelay changed val do (
setOutputsFromOutputUI()
)
on outputFireLimit changed val do (
setOutputsFromOutputUI()
)
on outputName selected sel do (
setOutputsFromOutputUI()
)
on outputInput selected sel do (
setOutputsFromOutputUI()
)
on outputParamOverride changed tex do (
setOutputsFromOutputUI()
)
on outputInput entered tex do (
	if tex == undefined OR tex=="" then (
		 false
	) else (
		if findItem outputInput.items tex == 0 then (
			temp = outputInput.items
append temp tex
			outputInput.items=temp
			if outputInput.items != undefined then (
				outputInput.selection = findItem outputInput.items tex
			)
		)
		setOutputsFromOutputUI()	
	) 
)
on outputTargetName changed tex do (
	if tex == undefined OR tex=="" then (
		false
	) else (
		local  theEffected = getCurrentInputs tex
		if theEffected.count > 0 then (
			flashnodes theEffected
			forceCompleteredraw()
			updateInputListFromObjs theEffected 
		)
		setOutputsFromOutputUI()		
	)
)
on addOutput pressed do
(
theOP = getProperty this #outputs 
 append theOP outputs_ui.text
outputs_ui.items = theOP as array
setProperty this #outputs theOP
outputs_ui.selection = theOP.count
setOutputsUIfromOutput outputs_ui.text
)
on getInputs picked obj do
(
outputInput.items = obj.availableInputs
if isProperty obj #targetname AND obj.targetname != "" then (
outputTargetName.text = obj.targetname
) else (
outputTargetName.text=obj.entName
)
setOutputsFromOutputUI()
)
on deleteOutput pressed do
(
 if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 deleteItem theOP outputs_ui.selection
setProperty this #outputs theOP
outputs_ui.items = theOP as array
)
)
on outputs_ui selected sel do
(
if outputs_ui.selection != 0 then (
 theOP = getProperty this #outputs
 setOutputsUIfromOutput theOP[sel]
 theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
flashnodes theEffected
forceCompleteredraw()
)
)
)
on outputs_ui rightClick do
(
if outputs_ui.selection != 0 then (
theEffected = getCurrentInputs outputTargetName.text
 if theEffected.count > 0 then (
select theEffected
)
)
)
on outputs_ui entered tex do (
 try (
setOutputsUIfromOutput tex
if outputs_ui.selection != 0 then (
theOP = getProperty this "outputs"
 theOP[outputs_ui.selection] = tex
setProperty this "outputs" theOP
setOutputsFromOutputUI()
)
) catch (messagebox ("Oops... the values you entered caused a problem. Divide all items with the > symbol. Press F11 for more info."))
)

group "Inputs"
(
button addInput "Refresh Inputs"
combobox inputslist "Current Input Entities"
button gotoInput "Go To Input"

)
on gotoInput pressed do
(
if inputslist.selection != 0 AND currentInputs[inputslist.selection] != undefined then (
select currentInputs[inputslist.selection]
)
)
on inputslist selected sel do (
 if sel != 0 AND currentInputs[sel] != undefined then (
flashNodes #(currentInputs[sel])
forceCompleteredraw()
)
)
on addInput pressed do
(
 getMyInputs()
inputslist.items = for obj in currentInputs collect obj.name
)
hyperlink wwbutton "Powered by Wall Worm" address:"http://dev.wallworm.com/core/pages/list/doc.php?docSearch[search]=func_reflective_glass&f7_submit=Search"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
hyperlink valvewikie "Wiki: func_reflective_glass" address:"https://developer.valvesoftware.com/wiki/func_reflective_glass?from=3ds+max+and+wallworm"  color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255)
on params open do (
 if solidity != undefined AND findItem propMapsolidity solidity == 0 then (
 append propMapsolidity solidity
tmp = wwmt_solidity_ui.items
 append tmp solidity
wwmt_solidity_ui.items = tmp
wwmt_solidity_ui.selection = propMapsolidity.count
) else ( 
 if solidity != undefined then (
wwmt_solidity_ui.selection = (findItem propMapsolidity solidity)
)
)
 if invert_exclusion != undefined AND findItem propMapinvert_exclusion invert_exclusion == 0 then (
 append propMapinvert_exclusion invert_exclusion
tmp = wwmt_invert_exclusion_ui.items
 append tmp invert_exclusion
wwmt_invert_exclusion_ui.items = tmp
wwmt_invert_exclusion_ui.selection = propMapinvert_exclusion.count
) else ( 
 if invert_exclusion != undefined then (
wwmt_invert_exclusion_ui.selection = (findItem propMapinvert_exclusion invert_exclusion)
)
)
 if solidbsp != undefined AND findItem propMapsolidbsp solidbsp == 0 then (
 append propMapsolidbsp solidbsp
tmp = wwmt_solidbsp_ui.items
 append tmp solidbsp
wwmt_solidbsp_ui.items = tmp
wwmt_solidbsp_ui.selection = propMapsolidbsp.count
) else ( 
 if solidbsp != undefined then (
wwmt_solidbsp_ui.selection = (findItem propMapsolidbsp solidbsp)
)
)
 if vrad_brush_cast_shadows != undefined AND findItem propMapvrad_brush_cast_shadows vrad_brush_cast_shadows == 0 then (
 append propMapvrad_brush_cast_shadows vrad_brush_cast_shadows
tmp = wwmt_vrad_brush_cast_shadows_ui.items
 append tmp vrad_brush_cast_shadows
wwmt_vrad_brush_cast_shadows_ui.items = tmp
wwmt_vrad_brush_cast_shadows_ui.selection = propMapvrad_brush_cast_shadows.count
) else ( 
 if vrad_brush_cast_shadows != undefined then (
wwmt_vrad_brush_cast_shadows_ui.selection = (findItem propMapvrad_brush_cast_shadows vrad_brush_cast_shadows)
)
)
 if rendermode != undefined AND findItem propMaprendermode rendermode == 0 then (
 append propMaprendermode rendermode
tmp = wwmt_rendermode_ui.items
 append tmp rendermode
wwmt_rendermode_ui.items = tmp
wwmt_rendermode_ui.selection = propMaprendermode.count
) else ( 
 if rendermode != undefined then (
wwmt_rendermode_ui.selection = (findItem propMaprendermode rendermode)
)
)
 if disablereceiveshadows != undefined AND findItem propMapdisablereceiveshadows disablereceiveshadows == 0 then (
 append propMapdisablereceiveshadows disablereceiveshadows
tmp = wwmt_disablereceiveshadows_ui.items
 append tmp disablereceiveshadows
wwmt_disablereceiveshadows_ui.items = tmp
wwmt_disablereceiveshadows_ui.selection = propMapdisablereceiveshadows.count
) else ( 
 if disablereceiveshadows != undefined then (
wwmt_disablereceiveshadows_ui.selection = (findItem propMapdisablereceiveshadows disablereceiveshadows)
)
)
 if renderfx != undefined AND findItem propMaprenderfx renderfx == 0 then (
 append propMaprenderfx renderfx
tmp = wwmt_renderfx_ui.items
 append tmp renderfx
wwmt_renderfx_ui.items = tmp
wwmt_renderfx_ui.selection = propMaprenderfx.count
) else ( 
 if renderfx != undefined then (
wwmt_renderfx_ui.selection = (findItem propMaprenderfx renderfx)
)
)
 if inputfilter != undefined AND findItem propMapinputfilter inputfilter == 0 then (
 append propMapinputfilter inputfilter
tmp = wwmt_inputfilter_ui.items
 append tmp inputfilter
wwmt_inputfilter_ui.items = tmp
wwmt_inputfilter_ui.selection = propMapinputfilter.count
) else ( 
 if inputfilter != undefined then (
wwmt_inputfilter_ui.selection = (findItem propMapinputfilter inputfilter)
)
)
 if startdisabled != undefined AND findItem propMapstartdisabled startdisabled == 0 then (
 append propMapstartdisabled startdisabled
tmp = wwmt_startdisabled_ui.items
 append tmp startdisabled
wwmt_startdisabled_ui.items = tmp
wwmt_startdisabled_ui.selection = propMapstartdisabled.count
) else ( 
 if startdisabled != undefined then (
wwmt_startdisabled_ui.selection = (findItem propMapstartdisabled startdisabled)
)
)
 if disableshadows != undefined AND findItem propMapdisableshadows disableshadows == 0 then (
 append propMapdisableshadows disableshadows
tmp = wwmt_disableshadows_ui.items
 append tmp disableshadows
wwmt_disableshadows_ui.items = tmp
wwmt_disableshadows_ui.selection = propMapdisableshadows.count
) else ( 
 if disableshadows != undefined then (
wwmt_disableshadows_ui.selection = (findItem propMapdisableshadows disableshadows)
)
)

if bit.and (getProperty this "spawnflags") 2 == 2 then (
flag_2_ui.checked = true
)
if  brushNodes != undefined and brushNodes.count > 0 then (
for i = brushNodes.count to 1 by -1 do (
if brushNodes[i] == undefined OR isDeleted brushNodes[i] == true then (
deleteItem brushNodes i
)
)
)
entityGroupList.items = updateBrushNodeList brushNodes
outputs_ui.items = (getProperty this #outputs) as array
outputs_ui.selection = 0

)

)
on clone orig do thisNode = undefined 

)
